<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvailabilityDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAvailabilityDetails
 * @subpackage Arrays
 */
class ArrayOfAvailabilityDetails extends AbstractStructArrayBase
{
    /**
     * The AvailabilityDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AvailabilityDetails[]
     */
    public $AvailabilityDetails;
    /**
     * Constructor method for ArrayOfAvailabilityDetails
     * @uses ArrayOfAvailabilityDetails::setAvailabilityDetails()
     * @param \StructType\AvailabilityDetails[] $availabilityDetails
     */
    public function __construct(array $availabilityDetails = array())
    {
        $this
            ->setAvailabilityDetails($availabilityDetails);
    }
    /**
     * Get AvailabilityDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AvailabilityDetails[]|null
     */
    public function getAvailabilityDetails()
    {
        return isset($this->AvailabilityDetails) ? $this->AvailabilityDetails : null;
    }
    /**
     * Set AvailabilityDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityDetails[] $availabilityDetails
     * @return \ArrayType\ArrayOfAvailabilityDetails
     */
    public function setAvailabilityDetails(array $availabilityDetails = array())
    {
        foreach ($availabilityDetails as $arrayOfAvailabilityDetailsAvailabilityDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvailabilityDetailsAvailabilityDetailsItem instanceof \StructType\AvailabilityDetails) {
                throw new \InvalidArgumentException(sprintf('The AvailabilityDetails property can only contain items of \StructType\AvailabilityDetails, "%s" given', is_object($arrayOfAvailabilityDetailsAvailabilityDetailsItem) ? get_class($arrayOfAvailabilityDetailsAvailabilityDetailsItem) : gettype($arrayOfAvailabilityDetailsAvailabilityDetailsItem)), __LINE__);
            }
        }
        if (is_null($availabilityDetails) || (is_array($availabilityDetails) && empty($availabilityDetails))) {
            unset($this->AvailabilityDetails);
        } else {
            $this->AvailabilityDetails = $availabilityDetails;
        }
        return $this;
    }
    /**
     * Add item to AvailabilityDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailabilityDetails $item
     * @return \ArrayType\ArrayOfAvailabilityDetails
     */
    public function addToAvailabilityDetails(\StructType\AvailabilityDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AvailabilityDetails) {
            throw new \InvalidArgumentException(sprintf('The AvailabilityDetails property can only contain items of \StructType\AvailabilityDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AvailabilityDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AvailabilityDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AvailabilityDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AvailabilityDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AvailabilityDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AvailabilityDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AvailabilityDetails
     */
    public function getAttributeName()
    {
        return 'AvailabilityDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAvailabilityDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
