<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabinetDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabinetDetail
 * @subpackage Arrays
 */
class ArrayOfCabinetDetail extends AbstractStructArrayBase
{
    /**
     * The CabinetDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabinetDetail[]
     */
    public $CabinetDetail;
    /**
     * Constructor method for ArrayOfCabinetDetail
     * @uses ArrayOfCabinetDetail::setCabinetDetail()
     * @param \StructType\CabinetDetail[] $cabinetDetail
     */
    public function __construct(array $cabinetDetail = array())
    {
        $this
            ->setCabinetDetail($cabinetDetail);
    }
    /**
     * Get CabinetDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabinetDetail[]|null
     */
    public function getCabinetDetail()
    {
        return isset($this->CabinetDetail) ? $this->CabinetDetail : null;
    }
    /**
     * Set CabinetDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabinetDetail[] $cabinetDetail
     * @return \ArrayType\ArrayOfCabinetDetail
     */
    public function setCabinetDetail(array $cabinetDetail = array())
    {
        foreach ($cabinetDetail as $arrayOfCabinetDetailCabinetDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabinetDetailCabinetDetailItem instanceof \StructType\CabinetDetail) {
                throw new \InvalidArgumentException(sprintf('The CabinetDetail property can only contain items of \StructType\CabinetDetail, "%s" given', is_object($arrayOfCabinetDetailCabinetDetailItem) ? get_class($arrayOfCabinetDetailCabinetDetailItem) : gettype($arrayOfCabinetDetailCabinetDetailItem)), __LINE__);
            }
        }
        if (is_null($cabinetDetail) || (is_array($cabinetDetail) && empty($cabinetDetail))) {
            unset($this->CabinetDetail);
        } else {
            $this->CabinetDetail = $cabinetDetail;
        }
        return $this;
    }
    /**
     * Add item to CabinetDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\CabinetDetail $item
     * @return \ArrayType\ArrayOfCabinetDetail
     */
    public function addToCabinetDetail(\StructType\CabinetDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabinetDetail) {
            throw new \InvalidArgumentException(sprintf('The CabinetDetail property can only contain items of \StructType\CabinetDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabinetDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabinetDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabinetDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabinetDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabinetDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabinetDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabinetDetail
     */
    public function getAttributeName()
    {
        return 'CabinetDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabinetDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
