<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEADAvailabilityResult ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEADAvailabilityResult
 * @subpackage Arrays
 */
class ArrayOfEADAvailabilityResult extends AbstractStructArrayBase
{
    /**
     * The EADAvailabilityResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EADAvailabilityResult[]
     */
    public $EADAvailabilityResult;
    /**
     * Constructor method for ArrayOfEADAvailabilityResult
     * @uses ArrayOfEADAvailabilityResult::setEADAvailabilityResult()
     * @param \StructType\EADAvailabilityResult[] $eADAvailabilityResult
     */
    public function __construct(array $eADAvailabilityResult = array())
    {
        $this
            ->setEADAvailabilityResult($eADAvailabilityResult);
    }
    /**
     * Get EADAvailabilityResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EADAvailabilityResult[]|null
     */
    public function getEADAvailabilityResult()
    {
        return isset($this->EADAvailabilityResult) ? $this->EADAvailabilityResult : null;
    }
    /**
     * Set EADAvailabilityResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EADAvailabilityResult[] $eADAvailabilityResult
     * @return \ArrayType\ArrayOfEADAvailabilityResult
     */
    public function setEADAvailabilityResult(array $eADAvailabilityResult = array())
    {
        foreach ($eADAvailabilityResult as $arrayOfEADAvailabilityResultEADAvailabilityResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfEADAvailabilityResultEADAvailabilityResultItem instanceof \StructType\EADAvailabilityResult) {
                throw new \InvalidArgumentException(sprintf('The EADAvailabilityResult property can only contain items of \StructType\EADAvailabilityResult, "%s" given', is_object($arrayOfEADAvailabilityResultEADAvailabilityResultItem) ? get_class($arrayOfEADAvailabilityResultEADAvailabilityResultItem) : gettype($arrayOfEADAvailabilityResultEADAvailabilityResultItem)), __LINE__);
            }
        }
        if (is_null($eADAvailabilityResult) || (is_array($eADAvailabilityResult) && empty($eADAvailabilityResult))) {
            unset($this->EADAvailabilityResult);
        } else {
            $this->EADAvailabilityResult = $eADAvailabilityResult;
        }
        return $this;
    }
    /**
     * Add item to EADAvailabilityResult value
     * @throws \InvalidArgumentException
     * @param \StructType\EADAvailabilityResult $item
     * @return \ArrayType\ArrayOfEADAvailabilityResult
     */
    public function addToEADAvailabilityResult(\StructType\EADAvailabilityResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EADAvailabilityResult) {
            throw new \InvalidArgumentException(sprintf('The EADAvailabilityResult property can only contain items of \StructType\EADAvailabilityResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EADAvailabilityResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EADAvailabilityResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EADAvailabilityResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EADAvailabilityResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EADAvailabilityResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EADAvailabilityResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EADAvailabilityResult
     */
    public function getAttributeName()
    {
        return 'EADAvailabilityResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEADAvailabilityResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
