<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEFMExchangeInfoType ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEFMExchangeInfoType
 * @subpackage Arrays
 */
class ArrayOfEFMExchangeInfoType extends AbstractStructArrayBase
{
    /**
     * The EFMExchangeInfoType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EFMExchangeInfoType[]
     */
    public $EFMExchangeInfoType;
    /**
     * Constructor method for ArrayOfEFMExchangeInfoType
     * @uses ArrayOfEFMExchangeInfoType::setEFMExchangeInfoType()
     * @param \StructType\EFMExchangeInfoType[] $eFMExchangeInfoType
     */
    public function __construct(array $eFMExchangeInfoType = array())
    {
        $this
            ->setEFMExchangeInfoType($eFMExchangeInfoType);
    }
    /**
     * Get EFMExchangeInfoType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EFMExchangeInfoType[]|null
     */
    public function getEFMExchangeInfoType()
    {
        return isset($this->EFMExchangeInfoType) ? $this->EFMExchangeInfoType : null;
    }
    /**
     * Set EFMExchangeInfoType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EFMExchangeInfoType[] $eFMExchangeInfoType
     * @return \ArrayType\ArrayOfEFMExchangeInfoType
     */
    public function setEFMExchangeInfoType(array $eFMExchangeInfoType = array())
    {
        foreach ($eFMExchangeInfoType as $arrayOfEFMExchangeInfoTypeEFMExchangeInfoTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfEFMExchangeInfoTypeEFMExchangeInfoTypeItem instanceof \StructType\EFMExchangeInfoType) {
                throw new \InvalidArgumentException(sprintf('The EFMExchangeInfoType property can only contain items of \StructType\EFMExchangeInfoType, "%s" given', is_object($arrayOfEFMExchangeInfoTypeEFMExchangeInfoTypeItem) ? get_class($arrayOfEFMExchangeInfoTypeEFMExchangeInfoTypeItem) : gettype($arrayOfEFMExchangeInfoTypeEFMExchangeInfoTypeItem)), __LINE__);
            }
        }
        if (is_null($eFMExchangeInfoType) || (is_array($eFMExchangeInfoType) && empty($eFMExchangeInfoType))) {
            unset($this->EFMExchangeInfoType);
        } else {
            $this->EFMExchangeInfoType = $eFMExchangeInfoType;
        }
        return $this;
    }
    /**
     * Add item to EFMExchangeInfoType value
     * @throws \InvalidArgumentException
     * @param \StructType\EFMExchangeInfoType $item
     * @return \ArrayType\ArrayOfEFMExchangeInfoType
     */
    public function addToEFMExchangeInfoType(\StructType\EFMExchangeInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EFMExchangeInfoType) {
            throw new \InvalidArgumentException(sprintf('The EFMExchangeInfoType property can only contain items of \StructType\EFMExchangeInfoType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EFMExchangeInfoType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EFMExchangeInfoType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EFMExchangeInfoType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EFMExchangeInfoType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EFMExchangeInfoType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EFMExchangeInfoType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EFMExchangeInfoType
     */
    public function getAttributeName()
    {
        return 'EFMExchangeInfoType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEFMExchangeInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
