<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNGARolloutDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNGARolloutDetails
 * @subpackage Arrays
 */
class ArrayOfNGARolloutDetails extends AbstractStructArrayBase
{
    /**
     * The NGARolloutDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NGARolloutDetails[]
     */
    public $NGARolloutDetails;
    /**
     * Constructor method for ArrayOfNGARolloutDetails
     * @uses ArrayOfNGARolloutDetails::setNGARolloutDetails()
     * @param \StructType\NGARolloutDetails[] $nGARolloutDetails
     */
    public function __construct(array $nGARolloutDetails = array())
    {
        $this
            ->setNGARolloutDetails($nGARolloutDetails);
    }
    /**
     * Get NGARolloutDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NGARolloutDetails[]|null
     */
    public function getNGARolloutDetails()
    {
        return isset($this->NGARolloutDetails) ? $this->NGARolloutDetails : null;
    }
    /**
     * Set NGARolloutDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\NGARolloutDetails[] $nGARolloutDetails
     * @return \ArrayType\ArrayOfNGARolloutDetails
     */
    public function setNGARolloutDetails(array $nGARolloutDetails = array())
    {
        foreach ($nGARolloutDetails as $arrayOfNGARolloutDetailsNGARolloutDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfNGARolloutDetailsNGARolloutDetailsItem instanceof \StructType\NGARolloutDetails) {
                throw new \InvalidArgumentException(sprintf('The NGARolloutDetails property can only contain items of \StructType\NGARolloutDetails, "%s" given', is_object($arrayOfNGARolloutDetailsNGARolloutDetailsItem) ? get_class($arrayOfNGARolloutDetailsNGARolloutDetailsItem) : gettype($arrayOfNGARolloutDetailsNGARolloutDetailsItem)), __LINE__);
            }
        }
        if (is_null($nGARolloutDetails) || (is_array($nGARolloutDetails) && empty($nGARolloutDetails))) {
            unset($this->NGARolloutDetails);
        } else {
            $this->NGARolloutDetails = $nGARolloutDetails;
        }
        return $this;
    }
    /**
     * Add item to NGARolloutDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\NGARolloutDetails $item
     * @return \ArrayType\ArrayOfNGARolloutDetails
     */
    public function addToNGARolloutDetails(\StructType\NGARolloutDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NGARolloutDetails) {
            throw new \InvalidArgumentException(sprintf('The NGARolloutDetails property can only contain items of \StructType\NGARolloutDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->NGARolloutDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\NGARolloutDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\NGARolloutDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\NGARolloutDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\NGARolloutDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\NGARolloutDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NGARolloutDetails
     */
    public function getAttributeName()
    {
        return 'NGARolloutDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfNGARolloutDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
