<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfThroughputSpeedType ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfThroughputSpeedType
 * @subpackage Arrays
 */
class ArrayOfThroughputSpeedType extends AbstractStructArrayBase
{
    /**
     * The ThroughputSpeedType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ThroughputSpeedType[]
     */
    public $ThroughputSpeedType;
    /**
     * Constructor method for ArrayOfThroughputSpeedType
     * @uses ArrayOfThroughputSpeedType::setThroughputSpeedType()
     * @param \StructType\ThroughputSpeedType[] $throughputSpeedType
     */
    public function __construct(array $throughputSpeedType = array())
    {
        $this
            ->setThroughputSpeedType($throughputSpeedType);
    }
    /**
     * Get ThroughputSpeedType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ThroughputSpeedType[]|null
     */
    public function getThroughputSpeedType()
    {
        return isset($this->ThroughputSpeedType) ? $this->ThroughputSpeedType : null;
    }
    /**
     * Set ThroughputSpeedType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ThroughputSpeedType[] $throughputSpeedType
     * @return \ArrayType\ArrayOfThroughputSpeedType
     */
    public function setThroughputSpeedType(array $throughputSpeedType = array())
    {
        foreach ($throughputSpeedType as $arrayOfThroughputSpeedTypeThroughputSpeedTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfThroughputSpeedTypeThroughputSpeedTypeItem instanceof \StructType\ThroughputSpeedType) {
                throw new \InvalidArgumentException(sprintf('The ThroughputSpeedType property can only contain items of \StructType\ThroughputSpeedType, "%s" given', is_object($arrayOfThroughputSpeedTypeThroughputSpeedTypeItem) ? get_class($arrayOfThroughputSpeedTypeThroughputSpeedTypeItem) : gettype($arrayOfThroughputSpeedTypeThroughputSpeedTypeItem)), __LINE__);
            }
        }
        if (is_null($throughputSpeedType) || (is_array($throughputSpeedType) && empty($throughputSpeedType))) {
            unset($this->ThroughputSpeedType);
        } else {
            $this->ThroughputSpeedType = $throughputSpeedType;
        }
        return $this;
    }
    /**
     * Add item to ThroughputSpeedType value
     * @throws \InvalidArgumentException
     * @param \StructType\ThroughputSpeedType $item
     * @return \ArrayType\ArrayOfThroughputSpeedType
     */
    public function addToThroughputSpeedType(\StructType\ThroughputSpeedType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ThroughputSpeedType) {
            throw new \InvalidArgumentException(sprintf('The ThroughputSpeedType property can only contain items of \StructType\ThroughputSpeedType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ThroughputSpeedType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ThroughputSpeedType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ThroughputSpeedType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ThroughputSpeedType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ThroughputSpeedType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ThroughputSpeedType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ThroughputSpeedType
     */
    public function getAttributeName()
    {
        return 'ThroughputSpeedType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfThroughputSpeedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
