<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVNEAvailability ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVNEAvailability
 * @subpackage Arrays
 */
class ArrayOfVNEAvailability extends AbstractStructArrayBase
{
    /**
     * The VNEAvailability
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VNEAvailability[]
     */
    public $VNEAvailability;
    /**
     * Constructor method for ArrayOfVNEAvailability
     * @uses ArrayOfVNEAvailability::setVNEAvailability()
     * @param \StructType\VNEAvailability[] $vNEAvailability
     */
    public function __construct(array $vNEAvailability = array())
    {
        $this
            ->setVNEAvailability($vNEAvailability);
    }
    /**
     * Get VNEAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VNEAvailability[]|null
     */
    public function getVNEAvailability()
    {
        return isset($this->VNEAvailability) ? $this->VNEAvailability : null;
    }
    /**
     * Set VNEAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VNEAvailability[] $vNEAvailability
     * @return \ArrayType\ArrayOfVNEAvailability
     */
    public function setVNEAvailability(array $vNEAvailability = array())
    {
        foreach ($vNEAvailability as $arrayOfVNEAvailabilityVNEAvailabilityItem) {
            // validation for constraint: itemType
            if (!$arrayOfVNEAvailabilityVNEAvailabilityItem instanceof \StructType\VNEAvailability) {
                throw new \InvalidArgumentException(sprintf('The VNEAvailability property can only contain items of \StructType\VNEAvailability, "%s" given', is_object($arrayOfVNEAvailabilityVNEAvailabilityItem) ? get_class($arrayOfVNEAvailabilityVNEAvailabilityItem) : gettype($arrayOfVNEAvailabilityVNEAvailabilityItem)), __LINE__);
            }
        }
        if (is_null($vNEAvailability) || (is_array($vNEAvailability) && empty($vNEAvailability))) {
            unset($this->VNEAvailability);
        } else {
            $this->VNEAvailability = $vNEAvailability;
        }
        return $this;
    }
    /**
     * Add item to VNEAvailability value
     * @throws \InvalidArgumentException
     * @param \StructType\VNEAvailability $item
     * @return \ArrayType\ArrayOfVNEAvailability
     */
    public function addToVNEAvailability(\StructType\VNEAvailability $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VNEAvailability) {
            throw new \InvalidArgumentException(sprintf('The VNEAvailability property can only contain items of \StructType\VNEAvailability, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VNEAvailability[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VNEAvailability|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VNEAvailability|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VNEAvailability|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VNEAvailability|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VNEAvailability|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VNEAvailability
     */
    public function getAttributeName()
    {
        return 'VNEAvailability';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVNEAvailability
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
