<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetAvailability' => '\\StructType\\GetAvailability',
            'NetworkProductAvailabilityRequest' => '\\StructType\\NetworkProductAvailabilityRequest',
            'NominatedCLIRequest' => '\\StructType\\NominatedCLIRequest',
            'AvailabilityRequest' => '\\StructType\\AvailabilityRequest',
            'AddressAvailabilityRequest' => '\\StructType\\AddressAvailabilityRequest',
            'GALKAvailabilityRequest' => '\\StructType\\GALKAvailabilityRequest',
            'NonGALKAvailabilityRequest' => '\\StructType\\NonGALKAvailabilityRequest',
            'PostcodeAvailabilityRequest' => '\\StructType\\PostcodeAvailabilityRequest',
            'TelephoneNumberAvailabilityRequest' => '\\StructType\\TelephoneNumberAvailabilityRequest',
            'UPRNAvailabilityRequest' => '\\StructType\\UPRNAvailabilityRequest',
            'AccessLineIDAvailabilityRequest' => '\\StructType\\AccessLineIDAvailabilityRequest',
            'GetAvailabilityResponse' => '\\StructType\\GetAvailabilityResponse',
            'NetworkProductAvailabilityResponse' => '\\StructType\\NetworkProductAvailabilityResponse',
            'ArrayOfAvailabilityDetails' => '\\ArrayType\\ArrayOfAvailabilityDetails',
            'AvailabilityDetails' => '\\StructType\\AvailabilityDetails',
            'EADAvailabilityDetails' => '\\StructType\\EADAvailabilityDetails',
            'ArrayOfEADAvailabilityResult' => '\\ArrayType\\ArrayOfEADAvailabilityResult',
            'EADAvailabilityResult' => '\\StructType\\EADAvailabilityResult',
            'ReslilienceInformationResult' => '\\StructType\\ReslilienceInformationResult',
            'FutureResilience' => '\\StructType\\FutureResilience',
            'EFMAvailabilityDetails' => '\\StructType\\EFMAvailabilityDetails',
            'ArrayOfAdditionalInformation' => '\\ArrayType\\ArrayOfAdditionalInformation',
            'AdditionalInformation' => '\\StructType\\AdditionalInformation',
            'ArrayOfEFMExchangeInfoType' => '\\ArrayType\\ArrayOfEFMExchangeInfoType',
            'EFMExchangeInfoType' => '\\StructType\\EFMExchangeInfoType',
            'ExchangeCapacityStatusType' => '\\StructType\\ExchangeCapacityStatusType',
            'ExchangeCapacityStatusTypeStatus' => '\\StructType\\ExchangeCapacityStatusTypeStatus',
            'TiePairInformationType' => '\\StructType\\TiePairInformationType',
            'EFMLineLengthType' => '\\StructType\\EFMLineLengthType',
            'TiePairBandwidthType' => '\\StructType\\TiePairBandwidthType',
            'FourTiePairBandwidthType' => '\\StructType\\FourTiePairBandwidthType',
            'TwoTiePairBandwidthType' => '\\StructType\\TwoTiePairBandwidthType',
            'MPFAvailabilityDetails' => '\\StructType\\MPFAvailabilityDetails',
            'DSLSpeedInformation' => '\\StructType\\DSLSpeedInformation',
            'DSLType' => '\\StructType\\DSLType',
            'LLUSyncSpeedType' => '\\StructType\\LLUSyncSpeedType',
            'ArrayOfThroughputSpeedType' => '\\ArrayType\\ArrayOfThroughputSpeedType',
            'ThroughputSpeedType' => '\\StructType\\ThroughputSpeedType',
            'LLUExchangeInfo' => '\\StructType\\LLUExchangeInfo',
            'LineLengthDetail' => '\\StructType\\LineLengthDetail',
            'ArrayOfProductMessage' => '\\ArrayType\\ArrayOfProductMessage',
            'ProductMessage' => '\\StructType\\ProductMessage',
            'ArrayOfProductAttribute' => '\\ArrayType\\ArrayOfProductAttribute',
            'ProductAttribute' => '\\StructType\\ProductAttribute',
            'LineType' => '\\StructType\\LineType',
            'StoppedLineType' => '\\StructType\\StoppedLineType',
            'ArrayOfOpenOrderInfo' => '\\ArrayType\\ArrayOfOpenOrderInfo',
            'OpenOrderInfo' => '\\StructType\\OpenOrderInfo',
            'DateTimeDetails' => '\\StructType\\DateTimeDetails',
            'WorkingLineType' => '\\StructType\\WorkingLineType',
            'ArrayOfLLUExchangeInfo' => '\\ArrayType\\ArrayOfLLUExchangeInfo',
            'LLUObservedSyncSpeedType' => '\\StructType\\LLUObservedSyncSpeedType',
            'ArrayOfTechnologyMessage' => '\\ArrayType\\ArrayOfTechnologyMessage',
            'TechnologyMessage' => '\\StructType\\TechnologyMessage',
            'SMPFAvailabilityDetails' => '\\StructType\\SMPFAvailabilityDetails',
            'NGAAvailabilityDetails' => '\\StructType\\NGAAvailabilityDetails',
            'ArrayOfServiceInfo' => '\\ArrayType\\ArrayOfServiceInfo',
            'ServiceInfo' => '\\StructType\\ServiceInfo',
            'FTTCInfo' => '\\StructType\\FTTCInfo',
            'FTTCSyncSpeedType' => '\\StructType\\FTTCSyncSpeedType',
            'ArrayOfNGAExchangeInfo' => '\\ArrayType\\ArrayOfNGAExchangeInfo',
            'NGAExchangeInfo' => '\\StructType\\NGAExchangeInfo',
            'RAGPercentageCoverage' => '\\StructType\\RAGPercentageCoverage',
            'ArrayOfNGAProductMessage' => '\\ArrayType\\ArrayOfNGAProductMessage',
            'NGAProductMessage' => '\\StructType\\NGAProductMessage',
            'ArrayOfNGARolloutDetails' => '\\ArrayType\\ArrayOfNGARolloutDetails',
            'NGARolloutDetails' => '\\StructType\\NGARolloutDetails',
            'ArrayOfCabinetDetail' => '\\ArrayType\\ArrayOfCabinetDetail',
            'CabinetDetail' => '\\StructType\\CabinetDetail',
            'FTTCObservedSyncSpeedType' => '\\StructType\\FTTCObservedSyncSpeedType',
            'PostcodeMatchInfo' => '\\StructType\\PostcodeMatchInfo',
            'OffnetAvailabilityDetails' => '\\StructType\\OffnetAvailabilityDetails',
            'ADSL2PLUSAvailabilityDetails' => '\\StructType\\ADSL2PLUSAvailabilityDetails',
            'WBCAnnexMAvailabilityDetails' => '\\StructType\\WBCAnnexMAvailabilityDetails',
            'ADSLAvailabilityDetails' => '\\StructType\\ADSLAvailabilityDetails',
            'AdditionalMessagesDetails' => '\\StructType\\AdditionalMessagesDetails',
            'OffnetExchangeDetails' => '\\StructType\\OffnetExchangeDetails',
            'OffnetLineDetails' => '\\StructType\\OffnetLineDetails',
            'OffnetLineManagementDetails' => '\\StructType\\OffnetLineManagementDetails',
            'FTTPAvailabilityDetails' => '\\StructType\\FTTPAvailabilityDetails',
            'ArrayOfFTTPAvailabilityDetails.FTTPAddressDetails' => '\\ArrayType\\ArrayOfFTTPAvailabilityDetails_FTTPAddressDetails',
            'FTTPAvailabilityDetails.FTTPAddressDetails' => '\\StructType\\FTTPAvailabilityDetails_FTTPAddressDetails',
            'OrdersInformation' => '\\StructType\\OrdersInformation',
            'ArrayOfOrderDetails' => '\\ArrayType\\ArrayOfOrderDetails',
            'OrderDetails' => '\\StructType\\OrderDetails',
            'VNEAvailabilityDetails' => '\\StructType\\VNEAvailabilityDetails',
            'ArrayOfVNEAvailability' => '\\ArrayType\\ArrayOfVNEAvailability',
            'VNEAvailability' => '\\StructType\\VNEAvailability',
            'EDFAAvailabilityDetails' => '\\StructType\\EDFAAvailabilityDetails',
            'ArrayOfEDFAAvailability' => '\\ArrayType\\ArrayOfEDFAAvailability',
            'EDFAAvailability' => '\\StructType\\EDFAAvailability',
            'NominatedCLIDetails' => '\\StructType\\NominatedCLIDetails',
            'GetResiliency' => '\\StructType\\GetResiliency',
            'NetworkProductResiliencyRequest' => '\\StructType\\NetworkProductResiliencyRequest',
            'PrimaryAccessIdentifier' => '\\StructType\\PrimaryAccessIdentifier',
            'PrimaryAccessCASR' => '\\StructType\\PrimaryAccessCASR',
            'PrimaryAccessExchangeCircuit' => '\\StructType\\PrimaryAccessExchangeCircuit',
            'ResiliencyRequest' => '\\StructType\\ResiliencyRequest',
            'PostcodeResiliencyRequest' => '\\StructType\\PostcodeResiliencyRequest',
            'GALKResiliencyRequest' => '\\StructType\\GALKResiliencyRequest',
            'GetResiliencyResponse' => '\\StructType\\GetResiliencyResponse',
            'NetworkProductResiliencyResponse' => '\\StructType\\NetworkProductResiliencyResponse',
            'AuthenticateRequestBase' => '\\StructType\\AuthenticateRequestBase',
            'RequestBase' => '\\StructType\\RequestBase',
            'Credentials' => '\\StructType\\Credentials',
            'ResponseBase' => '\\StructType\\ResponseBase',
            'Status' => '\\StructType\\Status',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
        );
    }
}
