<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthenticateRequestBase StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AuthenticateRequestBase
 * @subpackage Structs
 */
class AuthenticateRequestBase extends RequestBase
{
    /**
     * The UserCredentials
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $UserCredentials;
    /**
     * Constructor method for AuthenticateRequestBase
     * @uses AuthenticateRequestBase::setUserCredentials()
     * @param \StructType\Credentials $userCredentials
     */
    public function __construct(\StructType\Credentials $userCredentials = null)
    {
        $this
            ->setUserCredentials($userCredentials);
    }
    /**
     * Get UserCredentials value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getUserCredentials()
    {
        return isset($this->UserCredentials) ? $this->UserCredentials : null;
    }
    /**
     * Set UserCredentials value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $userCredentials
     * @return \StructType\AuthenticateRequestBase
     */
    public function setUserCredentials(\StructType\Credentials $userCredentials = null)
    {
        if (is_null($userCredentials) || (is_array($userCredentials) && empty($userCredentials))) {
            unset($this->UserCredentials);
        } else {
            $this->UserCredentials = $userCredentials;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AuthenticateRequestBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
