<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FTTCObservedSyncSpeedType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FTTCObservedSyncSpeedType
 * @subpackage Structs
 */
class FTTCObservedSyncSpeedType extends AbstractStructBase
{
    /**
     * The DownstreamDLMProfileCap
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamDLMProfileCap;
    /**
     * The DownstreamProductCap
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamProductCap;
    /**
     * The LastObservedDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastObservedDate;
    /**
     * The LowerDownstreamObservedSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LowerDownstreamObservedSpeed;
    /**
     * The LowerUpstreamObservedSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LowerUpstreamObservedSpeed;
    /**
     * The UpperDownstreamObservedSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpperDownstreamObservedSpeed;
    /**
     * The UpperUpstreamObservedSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpperUpstreamObservedSpeed;
    /**
     * The UpstreamDLMProfileCap
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamDLMProfileCap;
    /**
     * The UpstreamProductCap
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamProductCap;
    /**
     * Constructor method for FTTCObservedSyncSpeedType
     * @uses FTTCObservedSyncSpeedType::setDownstreamDLMProfileCap()
     * @uses FTTCObservedSyncSpeedType::setDownstreamProductCap()
     * @uses FTTCObservedSyncSpeedType::setLastObservedDate()
     * @uses FTTCObservedSyncSpeedType::setLowerDownstreamObservedSpeed()
     * @uses FTTCObservedSyncSpeedType::setLowerUpstreamObservedSpeed()
     * @uses FTTCObservedSyncSpeedType::setUpperDownstreamObservedSpeed()
     * @uses FTTCObservedSyncSpeedType::setUpperUpstreamObservedSpeed()
     * @uses FTTCObservedSyncSpeedType::setUpstreamDLMProfileCap()
     * @uses FTTCObservedSyncSpeedType::setUpstreamProductCap()
     * @param string $downstreamDLMProfileCap
     * @param string $downstreamProductCap
     * @param string $lastObservedDate
     * @param string $lowerDownstreamObservedSpeed
     * @param string $lowerUpstreamObservedSpeed
     * @param string $upperDownstreamObservedSpeed
     * @param string $upperUpstreamObservedSpeed
     * @param string $upstreamDLMProfileCap
     * @param string $upstreamProductCap
     */
    public function __construct($downstreamDLMProfileCap = null, $downstreamProductCap = null, $lastObservedDate = null, $lowerDownstreamObservedSpeed = null, $lowerUpstreamObservedSpeed = null, $upperDownstreamObservedSpeed = null, $upperUpstreamObservedSpeed = null, $upstreamDLMProfileCap = null, $upstreamProductCap = null)
    {
        $this
            ->setDownstreamDLMProfileCap($downstreamDLMProfileCap)
            ->setDownstreamProductCap($downstreamProductCap)
            ->setLastObservedDate($lastObservedDate)
            ->setLowerDownstreamObservedSpeed($lowerDownstreamObservedSpeed)
            ->setLowerUpstreamObservedSpeed($lowerUpstreamObservedSpeed)
            ->setUpperDownstreamObservedSpeed($upperDownstreamObservedSpeed)
            ->setUpperUpstreamObservedSpeed($upperUpstreamObservedSpeed)
            ->setUpstreamDLMProfileCap($upstreamDLMProfileCap)
            ->setUpstreamProductCap($upstreamProductCap);
    }
    /**
     * Get DownstreamDLMProfileCap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamDLMProfileCap()
    {
        return isset($this->DownstreamDLMProfileCap) ? $this->DownstreamDLMProfileCap : null;
    }
    /**
     * Set DownstreamDLMProfileCap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamDLMProfileCap
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setDownstreamDLMProfileCap($downstreamDLMProfileCap = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamDLMProfileCap) && !is_string($downstreamDLMProfileCap)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamDLMProfileCap)), __LINE__);
        }
        if (is_null($downstreamDLMProfileCap) || (is_array($downstreamDLMProfileCap) && empty($downstreamDLMProfileCap))) {
            unset($this->DownstreamDLMProfileCap);
        } else {
            $this->DownstreamDLMProfileCap = $downstreamDLMProfileCap;
        }
        return $this;
    }
    /**
     * Get DownstreamProductCap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamProductCap()
    {
        return isset($this->DownstreamProductCap) ? $this->DownstreamProductCap : null;
    }
    /**
     * Set DownstreamProductCap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamProductCap
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setDownstreamProductCap($downstreamProductCap = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamProductCap) && !is_string($downstreamProductCap)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamProductCap)), __LINE__);
        }
        if (is_null($downstreamProductCap) || (is_array($downstreamProductCap) && empty($downstreamProductCap))) {
            unset($this->DownstreamProductCap);
        } else {
            $this->DownstreamProductCap = $downstreamProductCap;
        }
        return $this;
    }
    /**
     * Get LastObservedDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastObservedDate()
    {
        return isset($this->LastObservedDate) ? $this->LastObservedDate : null;
    }
    /**
     * Set LastObservedDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastObservedDate
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setLastObservedDate($lastObservedDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastObservedDate) && !is_string($lastObservedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastObservedDate)), __LINE__);
        }
        if (is_null($lastObservedDate) || (is_array($lastObservedDate) && empty($lastObservedDate))) {
            unset($this->LastObservedDate);
        } else {
            $this->LastObservedDate = $lastObservedDate;
        }
        return $this;
    }
    /**
     * Get LowerDownstreamObservedSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLowerDownstreamObservedSpeed()
    {
        return isset($this->LowerDownstreamObservedSpeed) ? $this->LowerDownstreamObservedSpeed : null;
    }
    /**
     * Set LowerDownstreamObservedSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lowerDownstreamObservedSpeed
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setLowerDownstreamObservedSpeed($lowerDownstreamObservedSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($lowerDownstreamObservedSpeed) && !is_string($lowerDownstreamObservedSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lowerDownstreamObservedSpeed)), __LINE__);
        }
        if (is_null($lowerDownstreamObservedSpeed) || (is_array($lowerDownstreamObservedSpeed) && empty($lowerDownstreamObservedSpeed))) {
            unset($this->LowerDownstreamObservedSpeed);
        } else {
            $this->LowerDownstreamObservedSpeed = $lowerDownstreamObservedSpeed;
        }
        return $this;
    }
    /**
     * Get LowerUpstreamObservedSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLowerUpstreamObservedSpeed()
    {
        return isset($this->LowerUpstreamObservedSpeed) ? $this->LowerUpstreamObservedSpeed : null;
    }
    /**
     * Set LowerUpstreamObservedSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lowerUpstreamObservedSpeed
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setLowerUpstreamObservedSpeed($lowerUpstreamObservedSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($lowerUpstreamObservedSpeed) && !is_string($lowerUpstreamObservedSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lowerUpstreamObservedSpeed)), __LINE__);
        }
        if (is_null($lowerUpstreamObservedSpeed) || (is_array($lowerUpstreamObservedSpeed) && empty($lowerUpstreamObservedSpeed))) {
            unset($this->LowerUpstreamObservedSpeed);
        } else {
            $this->LowerUpstreamObservedSpeed = $lowerUpstreamObservedSpeed;
        }
        return $this;
    }
    /**
     * Get UpperDownstreamObservedSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpperDownstreamObservedSpeed()
    {
        return isset($this->UpperDownstreamObservedSpeed) ? $this->UpperDownstreamObservedSpeed : null;
    }
    /**
     * Set UpperDownstreamObservedSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upperDownstreamObservedSpeed
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setUpperDownstreamObservedSpeed($upperDownstreamObservedSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($upperDownstreamObservedSpeed) && !is_string($upperDownstreamObservedSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upperDownstreamObservedSpeed)), __LINE__);
        }
        if (is_null($upperDownstreamObservedSpeed) || (is_array($upperDownstreamObservedSpeed) && empty($upperDownstreamObservedSpeed))) {
            unset($this->UpperDownstreamObservedSpeed);
        } else {
            $this->UpperDownstreamObservedSpeed = $upperDownstreamObservedSpeed;
        }
        return $this;
    }
    /**
     * Get UpperUpstreamObservedSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpperUpstreamObservedSpeed()
    {
        return isset($this->UpperUpstreamObservedSpeed) ? $this->UpperUpstreamObservedSpeed : null;
    }
    /**
     * Set UpperUpstreamObservedSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upperUpstreamObservedSpeed
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setUpperUpstreamObservedSpeed($upperUpstreamObservedSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($upperUpstreamObservedSpeed) && !is_string($upperUpstreamObservedSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upperUpstreamObservedSpeed)), __LINE__);
        }
        if (is_null($upperUpstreamObservedSpeed) || (is_array($upperUpstreamObservedSpeed) && empty($upperUpstreamObservedSpeed))) {
            unset($this->UpperUpstreamObservedSpeed);
        } else {
            $this->UpperUpstreamObservedSpeed = $upperUpstreamObservedSpeed;
        }
        return $this;
    }
    /**
     * Get UpstreamDLMProfileCap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamDLMProfileCap()
    {
        return isset($this->UpstreamDLMProfileCap) ? $this->UpstreamDLMProfileCap : null;
    }
    /**
     * Set UpstreamDLMProfileCap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamDLMProfileCap
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setUpstreamDLMProfileCap($upstreamDLMProfileCap = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamDLMProfileCap) && !is_string($upstreamDLMProfileCap)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamDLMProfileCap)), __LINE__);
        }
        if (is_null($upstreamDLMProfileCap) || (is_array($upstreamDLMProfileCap) && empty($upstreamDLMProfileCap))) {
            unset($this->UpstreamDLMProfileCap);
        } else {
            $this->UpstreamDLMProfileCap = $upstreamDLMProfileCap;
        }
        return $this;
    }
    /**
     * Get UpstreamProductCap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamProductCap()
    {
        return isset($this->UpstreamProductCap) ? $this->UpstreamProductCap : null;
    }
    /**
     * Set UpstreamProductCap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamProductCap
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public function setUpstreamProductCap($upstreamProductCap = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamProductCap) && !is_string($upstreamProductCap)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamProductCap)), __LINE__);
        }
        if (is_null($upstreamProductCap) || (is_array($upstreamProductCap) && empty($upstreamProductCap))) {
            unset($this->UpstreamProductCap);
        } else {
            $this->UpstreamProductCap = $upstreamProductCap;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FTTCObservedSyncSpeedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
