<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LLUObservedSyncSpeedType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:LLUObservedSyncSpeedType
 * @subpackage Structs
 */
class LLUObservedSyncSpeedType extends AbstractStructBase
{
    /**
     * The DownstreamObservedMALR
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamObservedMALR;
    /**
     * The DownstreamObservedSyncSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamObservedSyncSpeed;
    /**
     * The LastObservedDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastObservedDate;
    /**
     * The UpstreamObservedMALR
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamObservedMALR;
    /**
     * The UpstreamObservedSyncSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamObservedSyncSpeed;
    /**
     * Constructor method for LLUObservedSyncSpeedType
     * @uses LLUObservedSyncSpeedType::setDownstreamObservedMALR()
     * @uses LLUObservedSyncSpeedType::setDownstreamObservedSyncSpeed()
     * @uses LLUObservedSyncSpeedType::setLastObservedDate()
     * @uses LLUObservedSyncSpeedType::setUpstreamObservedMALR()
     * @uses LLUObservedSyncSpeedType::setUpstreamObservedSyncSpeed()
     * @param string $downstreamObservedMALR
     * @param string $downstreamObservedSyncSpeed
     * @param string $lastObservedDate
     * @param string $upstreamObservedMALR
     * @param string $upstreamObservedSyncSpeed
     */
    public function __construct($downstreamObservedMALR = null, $downstreamObservedSyncSpeed = null, $lastObservedDate = null, $upstreamObservedMALR = null, $upstreamObservedSyncSpeed = null)
    {
        $this
            ->setDownstreamObservedMALR($downstreamObservedMALR)
            ->setDownstreamObservedSyncSpeed($downstreamObservedSyncSpeed)
            ->setLastObservedDate($lastObservedDate)
            ->setUpstreamObservedMALR($upstreamObservedMALR)
            ->setUpstreamObservedSyncSpeed($upstreamObservedSyncSpeed);
    }
    /**
     * Get DownstreamObservedMALR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamObservedMALR()
    {
        return isset($this->DownstreamObservedMALR) ? $this->DownstreamObservedMALR : null;
    }
    /**
     * Set DownstreamObservedMALR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamObservedMALR
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public function setDownstreamObservedMALR($downstreamObservedMALR = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamObservedMALR) && !is_string($downstreamObservedMALR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamObservedMALR)), __LINE__);
        }
        if (is_null($downstreamObservedMALR) || (is_array($downstreamObservedMALR) && empty($downstreamObservedMALR))) {
            unset($this->DownstreamObservedMALR);
        } else {
            $this->DownstreamObservedMALR = $downstreamObservedMALR;
        }
        return $this;
    }
    /**
     * Get DownstreamObservedSyncSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamObservedSyncSpeed()
    {
        return isset($this->DownstreamObservedSyncSpeed) ? $this->DownstreamObservedSyncSpeed : null;
    }
    /**
     * Set DownstreamObservedSyncSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamObservedSyncSpeed
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public function setDownstreamObservedSyncSpeed($downstreamObservedSyncSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamObservedSyncSpeed) && !is_string($downstreamObservedSyncSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamObservedSyncSpeed)), __LINE__);
        }
        if (is_null($downstreamObservedSyncSpeed) || (is_array($downstreamObservedSyncSpeed) && empty($downstreamObservedSyncSpeed))) {
            unset($this->DownstreamObservedSyncSpeed);
        } else {
            $this->DownstreamObservedSyncSpeed = $downstreamObservedSyncSpeed;
        }
        return $this;
    }
    /**
     * Get LastObservedDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastObservedDate()
    {
        return isset($this->LastObservedDate) ? $this->LastObservedDate : null;
    }
    /**
     * Set LastObservedDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastObservedDate
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public function setLastObservedDate($lastObservedDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastObservedDate) && !is_string($lastObservedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastObservedDate)), __LINE__);
        }
        if (is_null($lastObservedDate) || (is_array($lastObservedDate) && empty($lastObservedDate))) {
            unset($this->LastObservedDate);
        } else {
            $this->LastObservedDate = $lastObservedDate;
        }
        return $this;
    }
    /**
     * Get UpstreamObservedMALR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamObservedMALR()
    {
        return isset($this->UpstreamObservedMALR) ? $this->UpstreamObservedMALR : null;
    }
    /**
     * Set UpstreamObservedMALR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamObservedMALR
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public function setUpstreamObservedMALR($upstreamObservedMALR = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamObservedMALR) && !is_string($upstreamObservedMALR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamObservedMALR)), __LINE__);
        }
        if (is_null($upstreamObservedMALR) || (is_array($upstreamObservedMALR) && empty($upstreamObservedMALR))) {
            unset($this->UpstreamObservedMALR);
        } else {
            $this->UpstreamObservedMALR = $upstreamObservedMALR;
        }
        return $this;
    }
    /**
     * Get UpstreamObservedSyncSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamObservedSyncSpeed()
    {
        return isset($this->UpstreamObservedSyncSpeed) ? $this->UpstreamObservedSyncSpeed : null;
    }
    /**
     * Set UpstreamObservedSyncSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamObservedSyncSpeed
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public function setUpstreamObservedSyncSpeed($upstreamObservedSyncSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamObservedSyncSpeed) && !is_string($upstreamObservedSyncSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamObservedSyncSpeed)), __LINE__);
        }
        if (is_null($upstreamObservedSyncSpeed) || (is_array($upstreamObservedSyncSpeed) && empty($upstreamObservedSyncSpeed))) {
            unset($this->UpstreamObservedSyncSpeed);
        } else {
            $this->UpstreamObservedSyncSpeed = $upstreamObservedSyncSpeed;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LLUObservedSyncSpeedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
