<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LLUSyncSpeedType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:LLUSyncSpeedType
 * @subpackage Structs
 */
class LLUSyncSpeedType extends AbstractStructBase
{
    /**
     * The AnnexADownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexADownstream;
    /**
     * The AnnexAMaxRangeDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexAMaxRangeDownstream;
    /**
     * The AnnexAMinRangeDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexAMinRangeDownstream;
    /**
     * The AnnexMDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMDownstream;
    /**
     * The AnnexMMaxRangeDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMMaxRangeDownstream;
    /**
     * The AnnexMMaxRangeUpstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMMaxRangeUpstream;
    /**
     * The AnnexMMinRangeDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMMinRangeDownstream;
    /**
     * The AnnexMMinRangeUpstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMMinRangeUpstream;
    /**
     * The AnnexMUpstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AnnexMUpstream;
    /**
     * The MinThresholdAnnexADownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MinThresholdAnnexADownstream;
    /**
     * The MinThresholdAnnexMDownStream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MinThresholdAnnexMDownStream;
    /**
     * Constructor method for LLUSyncSpeedType
     * @uses LLUSyncSpeedType::setAnnexADownstream()
     * @uses LLUSyncSpeedType::setAnnexAMaxRangeDownstream()
     * @uses LLUSyncSpeedType::setAnnexAMinRangeDownstream()
     * @uses LLUSyncSpeedType::setAnnexMDownstream()
     * @uses LLUSyncSpeedType::setAnnexMMaxRangeDownstream()
     * @uses LLUSyncSpeedType::setAnnexMMaxRangeUpstream()
     * @uses LLUSyncSpeedType::setAnnexMMinRangeDownstream()
     * @uses LLUSyncSpeedType::setAnnexMMinRangeUpstream()
     * @uses LLUSyncSpeedType::setAnnexMUpstream()
     * @uses LLUSyncSpeedType::setMinThresholdAnnexADownstream()
     * @uses LLUSyncSpeedType::setMinThresholdAnnexMDownStream()
     * @param string $annexADownstream
     * @param string $annexAMaxRangeDownstream
     * @param string $annexAMinRangeDownstream
     * @param string $annexMDownstream
     * @param string $annexMMaxRangeDownstream
     * @param string $annexMMaxRangeUpstream
     * @param string $annexMMinRangeDownstream
     * @param string $annexMMinRangeUpstream
     * @param string $annexMUpstream
     * @param string $minThresholdAnnexADownstream
     * @param string $minThresholdAnnexMDownStream
     */
    public function __construct($annexADownstream = null, $annexAMaxRangeDownstream = null, $annexAMinRangeDownstream = null, $annexMDownstream = null, $annexMMaxRangeDownstream = null, $annexMMaxRangeUpstream = null, $annexMMinRangeDownstream = null, $annexMMinRangeUpstream = null, $annexMUpstream = null, $minThresholdAnnexADownstream = null, $minThresholdAnnexMDownStream = null)
    {
        $this
            ->setAnnexADownstream($annexADownstream)
            ->setAnnexAMaxRangeDownstream($annexAMaxRangeDownstream)
            ->setAnnexAMinRangeDownstream($annexAMinRangeDownstream)
            ->setAnnexMDownstream($annexMDownstream)
            ->setAnnexMMaxRangeDownstream($annexMMaxRangeDownstream)
            ->setAnnexMMaxRangeUpstream($annexMMaxRangeUpstream)
            ->setAnnexMMinRangeDownstream($annexMMinRangeDownstream)
            ->setAnnexMMinRangeUpstream($annexMMinRangeUpstream)
            ->setAnnexMUpstream($annexMUpstream)
            ->setMinThresholdAnnexADownstream($minThresholdAnnexADownstream)
            ->setMinThresholdAnnexMDownStream($minThresholdAnnexMDownStream);
    }
    /**
     * Get AnnexADownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexADownstream()
    {
        return isset($this->AnnexADownstream) ? $this->AnnexADownstream : null;
    }
    /**
     * Set AnnexADownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexADownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexADownstream($annexADownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexADownstream) && !is_string($annexADownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexADownstream)), __LINE__);
        }
        if (is_null($annexADownstream) || (is_array($annexADownstream) && empty($annexADownstream))) {
            unset($this->AnnexADownstream);
        } else {
            $this->AnnexADownstream = $annexADownstream;
        }
        return $this;
    }
    /**
     * Get AnnexAMaxRangeDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexAMaxRangeDownstream()
    {
        return isset($this->AnnexAMaxRangeDownstream) ? $this->AnnexAMaxRangeDownstream : null;
    }
    /**
     * Set AnnexAMaxRangeDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexAMaxRangeDownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexAMaxRangeDownstream($annexAMaxRangeDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexAMaxRangeDownstream) && !is_string($annexAMaxRangeDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexAMaxRangeDownstream)), __LINE__);
        }
        if (is_null($annexAMaxRangeDownstream) || (is_array($annexAMaxRangeDownstream) && empty($annexAMaxRangeDownstream))) {
            unset($this->AnnexAMaxRangeDownstream);
        } else {
            $this->AnnexAMaxRangeDownstream = $annexAMaxRangeDownstream;
        }
        return $this;
    }
    /**
     * Get AnnexAMinRangeDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexAMinRangeDownstream()
    {
        return isset($this->AnnexAMinRangeDownstream) ? $this->AnnexAMinRangeDownstream : null;
    }
    /**
     * Set AnnexAMinRangeDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexAMinRangeDownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexAMinRangeDownstream($annexAMinRangeDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexAMinRangeDownstream) && !is_string($annexAMinRangeDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexAMinRangeDownstream)), __LINE__);
        }
        if (is_null($annexAMinRangeDownstream) || (is_array($annexAMinRangeDownstream) && empty($annexAMinRangeDownstream))) {
            unset($this->AnnexAMinRangeDownstream);
        } else {
            $this->AnnexAMinRangeDownstream = $annexAMinRangeDownstream;
        }
        return $this;
    }
    /**
     * Get AnnexMDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMDownstream()
    {
        return isset($this->AnnexMDownstream) ? $this->AnnexMDownstream : null;
    }
    /**
     * Set AnnexMDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMDownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMDownstream($annexMDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMDownstream) && !is_string($annexMDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMDownstream)), __LINE__);
        }
        if (is_null($annexMDownstream) || (is_array($annexMDownstream) && empty($annexMDownstream))) {
            unset($this->AnnexMDownstream);
        } else {
            $this->AnnexMDownstream = $annexMDownstream;
        }
        return $this;
    }
    /**
     * Get AnnexMMaxRangeDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMMaxRangeDownstream()
    {
        return isset($this->AnnexMMaxRangeDownstream) ? $this->AnnexMMaxRangeDownstream : null;
    }
    /**
     * Set AnnexMMaxRangeDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMMaxRangeDownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMMaxRangeDownstream($annexMMaxRangeDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMMaxRangeDownstream) && !is_string($annexMMaxRangeDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMMaxRangeDownstream)), __LINE__);
        }
        if (is_null($annexMMaxRangeDownstream) || (is_array($annexMMaxRangeDownstream) && empty($annexMMaxRangeDownstream))) {
            unset($this->AnnexMMaxRangeDownstream);
        } else {
            $this->AnnexMMaxRangeDownstream = $annexMMaxRangeDownstream;
        }
        return $this;
    }
    /**
     * Get AnnexMMaxRangeUpstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMMaxRangeUpstream()
    {
        return isset($this->AnnexMMaxRangeUpstream) ? $this->AnnexMMaxRangeUpstream : null;
    }
    /**
     * Set AnnexMMaxRangeUpstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMMaxRangeUpstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMMaxRangeUpstream($annexMMaxRangeUpstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMMaxRangeUpstream) && !is_string($annexMMaxRangeUpstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMMaxRangeUpstream)), __LINE__);
        }
        if (is_null($annexMMaxRangeUpstream) || (is_array($annexMMaxRangeUpstream) && empty($annexMMaxRangeUpstream))) {
            unset($this->AnnexMMaxRangeUpstream);
        } else {
            $this->AnnexMMaxRangeUpstream = $annexMMaxRangeUpstream;
        }
        return $this;
    }
    /**
     * Get AnnexMMinRangeDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMMinRangeDownstream()
    {
        return isset($this->AnnexMMinRangeDownstream) ? $this->AnnexMMinRangeDownstream : null;
    }
    /**
     * Set AnnexMMinRangeDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMMinRangeDownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMMinRangeDownstream($annexMMinRangeDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMMinRangeDownstream) && !is_string($annexMMinRangeDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMMinRangeDownstream)), __LINE__);
        }
        if (is_null($annexMMinRangeDownstream) || (is_array($annexMMinRangeDownstream) && empty($annexMMinRangeDownstream))) {
            unset($this->AnnexMMinRangeDownstream);
        } else {
            $this->AnnexMMinRangeDownstream = $annexMMinRangeDownstream;
        }
        return $this;
    }
    /**
     * Get AnnexMMinRangeUpstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMMinRangeUpstream()
    {
        return isset($this->AnnexMMinRangeUpstream) ? $this->AnnexMMinRangeUpstream : null;
    }
    /**
     * Set AnnexMMinRangeUpstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMMinRangeUpstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMMinRangeUpstream($annexMMinRangeUpstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMMinRangeUpstream) && !is_string($annexMMinRangeUpstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMMinRangeUpstream)), __LINE__);
        }
        if (is_null($annexMMinRangeUpstream) || (is_array($annexMMinRangeUpstream) && empty($annexMMinRangeUpstream))) {
            unset($this->AnnexMMinRangeUpstream);
        } else {
            $this->AnnexMMinRangeUpstream = $annexMMinRangeUpstream;
        }
        return $this;
    }
    /**
     * Get AnnexMUpstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAnnexMUpstream()
    {
        return isset($this->AnnexMUpstream) ? $this->AnnexMUpstream : null;
    }
    /**
     * Set AnnexMUpstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $annexMUpstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setAnnexMUpstream($annexMUpstream = null)
    {
        // validation for constraint: string
        if (!is_null($annexMUpstream) && !is_string($annexMUpstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($annexMUpstream)), __LINE__);
        }
        if (is_null($annexMUpstream) || (is_array($annexMUpstream) && empty($annexMUpstream))) {
            unset($this->AnnexMUpstream);
        } else {
            $this->AnnexMUpstream = $annexMUpstream;
        }
        return $this;
    }
    /**
     * Get MinThresholdAnnexADownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMinThresholdAnnexADownstream()
    {
        return isset($this->MinThresholdAnnexADownstream) ? $this->MinThresholdAnnexADownstream : null;
    }
    /**
     * Set MinThresholdAnnexADownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $minThresholdAnnexADownstream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setMinThresholdAnnexADownstream($minThresholdAnnexADownstream = null)
    {
        // validation for constraint: string
        if (!is_null($minThresholdAnnexADownstream) && !is_string($minThresholdAnnexADownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minThresholdAnnexADownstream)), __LINE__);
        }
        if (is_null($minThresholdAnnexADownstream) || (is_array($minThresholdAnnexADownstream) && empty($minThresholdAnnexADownstream))) {
            unset($this->MinThresholdAnnexADownstream);
        } else {
            $this->MinThresholdAnnexADownstream = $minThresholdAnnexADownstream;
        }
        return $this;
    }
    /**
     * Get MinThresholdAnnexMDownStream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMinThresholdAnnexMDownStream()
    {
        return isset($this->MinThresholdAnnexMDownStream) ? $this->MinThresholdAnnexMDownStream : null;
    }
    /**
     * Set MinThresholdAnnexMDownStream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $minThresholdAnnexMDownStream
     * @return \StructType\LLUSyncSpeedType
     */
    public function setMinThresholdAnnexMDownStream($minThresholdAnnexMDownStream = null)
    {
        // validation for constraint: string
        if (!is_null($minThresholdAnnexMDownStream) && !is_string($minThresholdAnnexMDownStream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minThresholdAnnexMDownStream)), __LINE__);
        }
        if (is_null($minThresholdAnnexMDownStream) || (is_array($minThresholdAnnexMDownStream) && empty($minThresholdAnnexMDownStream))) {
            unset($this->MinThresholdAnnexMDownStream);
        } else {
            $this->MinThresholdAnnexMDownStream = $minThresholdAnnexMDownStream;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LLUSyncSpeedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
