<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LineType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:LineType
 * @subpackage Structs
 */
class LineType extends AbstractStructBase
{
    /**
     * The StoppedLineDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StoppedLineType
     */
    public $StoppedLineDetails;
    /**
     * The WorkingLineDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WorkingLineType
     */
    public $WorkingLineDetails;
    /**
     * Constructor method for LineType
     * @uses LineType::setStoppedLineDetails()
     * @uses LineType::setWorkingLineDetails()
     * @param \StructType\StoppedLineType $stoppedLineDetails
     * @param \StructType\WorkingLineType $workingLineDetails
     */
    public function __construct(\StructType\StoppedLineType $stoppedLineDetails = null, \StructType\WorkingLineType $workingLineDetails = null)
    {
        $this
            ->setStoppedLineDetails($stoppedLineDetails)
            ->setWorkingLineDetails($workingLineDetails);
    }
    /**
     * Get StoppedLineDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StoppedLineType|null
     */
    public function getStoppedLineDetails()
    {
        return isset($this->StoppedLineDetails) ? $this->StoppedLineDetails : null;
    }
    /**
     * Set StoppedLineDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StoppedLineType $stoppedLineDetails
     * @return \StructType\LineType
     */
    public function setStoppedLineDetails(\StructType\StoppedLineType $stoppedLineDetails = null)
    {
        if (is_null($stoppedLineDetails) || (is_array($stoppedLineDetails) && empty($stoppedLineDetails))) {
            unset($this->StoppedLineDetails);
        } else {
            $this->StoppedLineDetails = $stoppedLineDetails;
        }
        return $this;
    }
    /**
     * Get WorkingLineDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WorkingLineType|null
     */
    public function getWorkingLineDetails()
    {
        return isset($this->WorkingLineDetails) ? $this->WorkingLineDetails : null;
    }
    /**
     * Set WorkingLineDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WorkingLineType $workingLineDetails
     * @return \StructType\LineType
     */
    public function setWorkingLineDetails(\StructType\WorkingLineType $workingLineDetails = null)
    {
        if (is_null($workingLineDetails) || (is_array($workingLineDetails) && empty($workingLineDetails))) {
            unset($this->WorkingLineDetails);
        } else {
            $this->WorkingLineDetails = $workingLineDetails;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LineType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
