<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NGARolloutDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:NGARolloutDetails
 * @subpackage Structs
 */
class NGARolloutDetails extends AbstractStructBase
{
    /**
     * The CabinetDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCabinetDetail
     */
    public $CabinetDetails;
    /**
     * The MPFExchangeCapacity
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MPFExchangeCapacity;
    /**
     * The MPFExchangeCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MPFExchangeCode;
    /**
     * The MPFExchangeName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MPFExchangeName;
    /**
     * The MPFExchangeState
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MPFExchangeState;
    /**
     * Constructor method for NGARolloutDetails
     * @uses NGARolloutDetails::setCabinetDetails()
     * @uses NGARolloutDetails::setMPFExchangeCapacity()
     * @uses NGARolloutDetails::setMPFExchangeCode()
     * @uses NGARolloutDetails::setMPFExchangeName()
     * @uses NGARolloutDetails::setMPFExchangeState()
     * @param \ArrayType\ArrayOfCabinetDetail $cabinetDetails
     * @param string $mPFExchangeCapacity
     * @param string $mPFExchangeCode
     * @param string $mPFExchangeName
     * @param string $mPFExchangeState
     */
    public function __construct(\ArrayType\ArrayOfCabinetDetail $cabinetDetails = null, $mPFExchangeCapacity = null, $mPFExchangeCode = null, $mPFExchangeName = null, $mPFExchangeState = null)
    {
        $this
            ->setCabinetDetails($cabinetDetails)
            ->setMPFExchangeCapacity($mPFExchangeCapacity)
            ->setMPFExchangeCode($mPFExchangeCode)
            ->setMPFExchangeName($mPFExchangeName)
            ->setMPFExchangeState($mPFExchangeState);
    }
    /**
     * Get CabinetDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCabinetDetail|null
     */
    public function getCabinetDetails()
    {
        return isset($this->CabinetDetails) ? $this->CabinetDetails : null;
    }
    /**
     * Set CabinetDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCabinetDetail $cabinetDetails
     * @return \StructType\NGARolloutDetails
     */
    public function setCabinetDetails(\ArrayType\ArrayOfCabinetDetail $cabinetDetails = null)
    {
        if (is_null($cabinetDetails) || (is_array($cabinetDetails) && empty($cabinetDetails))) {
            unset($this->CabinetDetails);
        } else {
            $this->CabinetDetails = $cabinetDetails;
        }
        return $this;
    }
    /**
     * Get MPFExchangeCapacity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMPFExchangeCapacity()
    {
        return isset($this->MPFExchangeCapacity) ? $this->MPFExchangeCapacity : null;
    }
    /**
     * Set MPFExchangeCapacity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mPFExchangeCapacity
     * @return \StructType\NGARolloutDetails
     */
    public function setMPFExchangeCapacity($mPFExchangeCapacity = null)
    {
        // validation for constraint: string
        if (!is_null($mPFExchangeCapacity) && !is_string($mPFExchangeCapacity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mPFExchangeCapacity)), __LINE__);
        }
        if (is_null($mPFExchangeCapacity) || (is_array($mPFExchangeCapacity) && empty($mPFExchangeCapacity))) {
            unset($this->MPFExchangeCapacity);
        } else {
            $this->MPFExchangeCapacity = $mPFExchangeCapacity;
        }
        return $this;
    }
    /**
     * Get MPFExchangeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMPFExchangeCode()
    {
        return isset($this->MPFExchangeCode) ? $this->MPFExchangeCode : null;
    }
    /**
     * Set MPFExchangeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mPFExchangeCode
     * @return \StructType\NGARolloutDetails
     */
    public function setMPFExchangeCode($mPFExchangeCode = null)
    {
        // validation for constraint: string
        if (!is_null($mPFExchangeCode) && !is_string($mPFExchangeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mPFExchangeCode)), __LINE__);
        }
        if (is_null($mPFExchangeCode) || (is_array($mPFExchangeCode) && empty($mPFExchangeCode))) {
            unset($this->MPFExchangeCode);
        } else {
            $this->MPFExchangeCode = $mPFExchangeCode;
        }
        return $this;
    }
    /**
     * Get MPFExchangeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMPFExchangeName()
    {
        return isset($this->MPFExchangeName) ? $this->MPFExchangeName : null;
    }
    /**
     * Set MPFExchangeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mPFExchangeName
     * @return \StructType\NGARolloutDetails
     */
    public function setMPFExchangeName($mPFExchangeName = null)
    {
        // validation for constraint: string
        if (!is_null($mPFExchangeName) && !is_string($mPFExchangeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mPFExchangeName)), __LINE__);
        }
        if (is_null($mPFExchangeName) || (is_array($mPFExchangeName) && empty($mPFExchangeName))) {
            unset($this->MPFExchangeName);
        } else {
            $this->MPFExchangeName = $mPFExchangeName;
        }
        return $this;
    }
    /**
     * Get MPFExchangeState value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMPFExchangeState()
    {
        return isset($this->MPFExchangeState) ? $this->MPFExchangeState : null;
    }
    /**
     * Set MPFExchangeState value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mPFExchangeState
     * @return \StructType\NGARolloutDetails
     */
    public function setMPFExchangeState($mPFExchangeState = null)
    {
        // validation for constraint: string
        if (!is_null($mPFExchangeState) && !is_string($mPFExchangeState)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mPFExchangeState)), __LINE__);
        }
        if (is_null($mPFExchangeState) || (is_array($mPFExchangeState) && empty($mPFExchangeState))) {
            unset($this->MPFExchangeState);
        } else {
            $this->MPFExchangeState = $mPFExchangeState;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NGARolloutDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
