<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NetworkProductResiliencyResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:NetworkProductResiliencyResponse
 * @subpackage Structs
 */
class NetworkProductResiliencyResponse extends ResponseBase
{
    /**
     * The CSSDistrictCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CSSDistrictCode;
    /**
     * The EADAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $EADAvailability;
    /**
     * The EDFAAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $EDFAAvailability;
    /**
     * The EFMAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $EFMAvailability;
    /**
     * The EoFTTCAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $EoFTTCAvailability;
    /**
     * The FTTCAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $FTTCAvailability;
    /**
     * The GoldAddressKey
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GoldAddressKey;
    /**
     * The MPFAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $MPFAvailability;
    /**
     * The NonGoldAddressKey
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NonGoldAddressKey;
    /**
     * The OffnetAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $OffnetAvailability;
    /**
     * The Postcode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Postcode;
    /**
     * The SMPFAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $SMPFAvailability;
    /**
     * The VNEAvailability
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAvailabilityDetails
     */
    public $VNEAvailability;
    /**
     * Constructor method for NetworkProductResiliencyResponse
     * @uses NetworkProductResiliencyResponse::setCSSDistrictCode()
     * @uses NetworkProductResiliencyResponse::setEADAvailability()
     * @uses NetworkProductResiliencyResponse::setEDFAAvailability()
     * @uses NetworkProductResiliencyResponse::setEFMAvailability()
     * @uses NetworkProductResiliencyResponse::setEoFTTCAvailability()
     * @uses NetworkProductResiliencyResponse::setFTTCAvailability()
     * @uses NetworkProductResiliencyResponse::setGoldAddressKey()
     * @uses NetworkProductResiliencyResponse::setMPFAvailability()
     * @uses NetworkProductResiliencyResponse::setNonGoldAddressKey()
     * @uses NetworkProductResiliencyResponse::setOffnetAvailability()
     * @uses NetworkProductResiliencyResponse::setPostcode()
     * @uses NetworkProductResiliencyResponse::setSMPFAvailability()
     * @uses NetworkProductResiliencyResponse::setVNEAvailability()
     * @param string $cSSDistrictCode
     * @param \ArrayType\ArrayOfAvailabilityDetails $eADAvailability
     * @param \ArrayType\ArrayOfAvailabilityDetails $eDFAAvailability
     * @param \ArrayType\ArrayOfAvailabilityDetails $eFMAvailability
     * @param \ArrayType\ArrayOfAvailabilityDetails $eoFTTCAvailability
     * @param \ArrayType\ArrayOfAvailabilityDetails $fTTCAvailability
     * @param string $goldAddressKey
     * @param \ArrayType\ArrayOfAvailabilityDetails $mPFAvailability
     * @param string $nonGoldAddressKey
     * @param \ArrayType\ArrayOfAvailabilityDetails $offnetAvailability
     * @param string $postcode
     * @param \ArrayType\ArrayOfAvailabilityDetails $sMPFAvailability
     * @param \ArrayType\ArrayOfAvailabilityDetails $vNEAvailability
     */
    public function __construct($cSSDistrictCode = null, \ArrayType\ArrayOfAvailabilityDetails $eADAvailability = null, \ArrayType\ArrayOfAvailabilityDetails $eDFAAvailability = null, \ArrayType\ArrayOfAvailabilityDetails $eFMAvailability = null, \ArrayType\ArrayOfAvailabilityDetails $eoFTTCAvailability = null, \ArrayType\ArrayOfAvailabilityDetails $fTTCAvailability = null, $goldAddressKey = null, \ArrayType\ArrayOfAvailabilityDetails $mPFAvailability = null, $nonGoldAddressKey = null, \ArrayType\ArrayOfAvailabilityDetails $offnetAvailability = null, $postcode = null, \ArrayType\ArrayOfAvailabilityDetails $sMPFAvailability = null, \ArrayType\ArrayOfAvailabilityDetails $vNEAvailability = null)
    {
        $this
            ->setCSSDistrictCode($cSSDistrictCode)
            ->setEADAvailability($eADAvailability)
            ->setEDFAAvailability($eDFAAvailability)
            ->setEFMAvailability($eFMAvailability)
            ->setEoFTTCAvailability($eoFTTCAvailability)
            ->setFTTCAvailability($fTTCAvailability)
            ->setGoldAddressKey($goldAddressKey)
            ->setMPFAvailability($mPFAvailability)
            ->setNonGoldAddressKey($nonGoldAddressKey)
            ->setOffnetAvailability($offnetAvailability)
            ->setPostcode($postcode)
            ->setSMPFAvailability($sMPFAvailability)
            ->setVNEAvailability($vNEAvailability);
    }
    /**
     * Get CSSDistrictCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCSSDistrictCode()
    {
        return isset($this->CSSDistrictCode) ? $this->CSSDistrictCode : null;
    }
    /**
     * Set CSSDistrictCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cSSDistrictCode
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setCSSDistrictCode($cSSDistrictCode = null)
    {
        // validation for constraint: string
        if (!is_null($cSSDistrictCode) && !is_string($cSSDistrictCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cSSDistrictCode)), __LINE__);
        }
        if (is_null($cSSDistrictCode) || (is_array($cSSDistrictCode) && empty($cSSDistrictCode))) {
            unset($this->CSSDistrictCode);
        } else {
            $this->CSSDistrictCode = $cSSDistrictCode;
        }
        return $this;
    }
    /**
     * Get EADAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getEADAvailability()
    {
        return isset($this->EADAvailability) ? $this->EADAvailability : null;
    }
    /**
     * Set EADAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $eADAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setEADAvailability(\ArrayType\ArrayOfAvailabilityDetails $eADAvailability = null)
    {
        if (is_null($eADAvailability) || (is_array($eADAvailability) && empty($eADAvailability))) {
            unset($this->EADAvailability);
        } else {
            $this->EADAvailability = $eADAvailability;
        }
        return $this;
    }
    /**
     * Get EDFAAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getEDFAAvailability()
    {
        return isset($this->EDFAAvailability) ? $this->EDFAAvailability : null;
    }
    /**
     * Set EDFAAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $eDFAAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setEDFAAvailability(\ArrayType\ArrayOfAvailabilityDetails $eDFAAvailability = null)
    {
        if (is_null($eDFAAvailability) || (is_array($eDFAAvailability) && empty($eDFAAvailability))) {
            unset($this->EDFAAvailability);
        } else {
            $this->EDFAAvailability = $eDFAAvailability;
        }
        return $this;
    }
    /**
     * Get EFMAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getEFMAvailability()
    {
        return isset($this->EFMAvailability) ? $this->EFMAvailability : null;
    }
    /**
     * Set EFMAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $eFMAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setEFMAvailability(\ArrayType\ArrayOfAvailabilityDetails $eFMAvailability = null)
    {
        if (is_null($eFMAvailability) || (is_array($eFMAvailability) && empty($eFMAvailability))) {
            unset($this->EFMAvailability);
        } else {
            $this->EFMAvailability = $eFMAvailability;
        }
        return $this;
    }
    /**
     * Get EoFTTCAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getEoFTTCAvailability()
    {
        return isset($this->EoFTTCAvailability) ? $this->EoFTTCAvailability : null;
    }
    /**
     * Set EoFTTCAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $eoFTTCAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setEoFTTCAvailability(\ArrayType\ArrayOfAvailabilityDetails $eoFTTCAvailability = null)
    {
        if (is_null($eoFTTCAvailability) || (is_array($eoFTTCAvailability) && empty($eoFTTCAvailability))) {
            unset($this->EoFTTCAvailability);
        } else {
            $this->EoFTTCAvailability = $eoFTTCAvailability;
        }
        return $this;
    }
    /**
     * Get FTTCAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getFTTCAvailability()
    {
        return isset($this->FTTCAvailability) ? $this->FTTCAvailability : null;
    }
    /**
     * Set FTTCAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $fTTCAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setFTTCAvailability(\ArrayType\ArrayOfAvailabilityDetails $fTTCAvailability = null)
    {
        if (is_null($fTTCAvailability) || (is_array($fTTCAvailability) && empty($fTTCAvailability))) {
            unset($this->FTTCAvailability);
        } else {
            $this->FTTCAvailability = $fTTCAvailability;
        }
        return $this;
    }
    /**
     * Get GoldAddressKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGoldAddressKey()
    {
        return isset($this->GoldAddressKey) ? $this->GoldAddressKey : null;
    }
    /**
     * Set GoldAddressKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $goldAddressKey
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setGoldAddressKey($goldAddressKey = null)
    {
        // validation for constraint: string
        if (!is_null($goldAddressKey) && !is_string($goldAddressKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($goldAddressKey)), __LINE__);
        }
        if (is_null($goldAddressKey) || (is_array($goldAddressKey) && empty($goldAddressKey))) {
            unset($this->GoldAddressKey);
        } else {
            $this->GoldAddressKey = $goldAddressKey;
        }
        return $this;
    }
    /**
     * Get MPFAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getMPFAvailability()
    {
        return isset($this->MPFAvailability) ? $this->MPFAvailability : null;
    }
    /**
     * Set MPFAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $mPFAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setMPFAvailability(\ArrayType\ArrayOfAvailabilityDetails $mPFAvailability = null)
    {
        if (is_null($mPFAvailability) || (is_array($mPFAvailability) && empty($mPFAvailability))) {
            unset($this->MPFAvailability);
        } else {
            $this->MPFAvailability = $mPFAvailability;
        }
        return $this;
    }
    /**
     * Get NonGoldAddressKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNonGoldAddressKey()
    {
        return isset($this->NonGoldAddressKey) ? $this->NonGoldAddressKey : null;
    }
    /**
     * Set NonGoldAddressKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nonGoldAddressKey
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setNonGoldAddressKey($nonGoldAddressKey = null)
    {
        // validation for constraint: string
        if (!is_null($nonGoldAddressKey) && !is_string($nonGoldAddressKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nonGoldAddressKey)), __LINE__);
        }
        if (is_null($nonGoldAddressKey) || (is_array($nonGoldAddressKey) && empty($nonGoldAddressKey))) {
            unset($this->NonGoldAddressKey);
        } else {
            $this->NonGoldAddressKey = $nonGoldAddressKey;
        }
        return $this;
    }
    /**
     * Get OffnetAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getOffnetAvailability()
    {
        return isset($this->OffnetAvailability) ? $this->OffnetAvailability : null;
    }
    /**
     * Set OffnetAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $offnetAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setOffnetAvailability(\ArrayType\ArrayOfAvailabilityDetails $offnetAvailability = null)
    {
        if (is_null($offnetAvailability) || (is_array($offnetAvailability) && empty($offnetAvailability))) {
            unset($this->OffnetAvailability);
        } else {
            $this->OffnetAvailability = $offnetAvailability;
        }
        return $this;
    }
    /**
     * Get Postcode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPostcode()
    {
        return isset($this->Postcode) ? $this->Postcode : null;
    }
    /**
     * Set Postcode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $postcode
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($postcode)), __LINE__);
        }
        if (is_null($postcode) || (is_array($postcode) && empty($postcode))) {
            unset($this->Postcode);
        } else {
            $this->Postcode = $postcode;
        }
        return $this;
    }
    /**
     * Get SMPFAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getSMPFAvailability()
    {
        return isset($this->SMPFAvailability) ? $this->SMPFAvailability : null;
    }
    /**
     * Set SMPFAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $sMPFAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setSMPFAvailability(\ArrayType\ArrayOfAvailabilityDetails $sMPFAvailability = null)
    {
        if (is_null($sMPFAvailability) || (is_array($sMPFAvailability) && empty($sMPFAvailability))) {
            unset($this->SMPFAvailability);
        } else {
            $this->SMPFAvailability = $sMPFAvailability;
        }
        return $this;
    }
    /**
     * Get VNEAvailability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAvailabilityDetails|null
     */
    public function getVNEAvailability()
    {
        return isset($this->VNEAvailability) ? $this->VNEAvailability : null;
    }
    /**
     * Set VNEAvailability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAvailabilityDetails $vNEAvailability
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public function setVNEAvailability(\ArrayType\ArrayOfAvailabilityDetails $vNEAvailability = null)
    {
        if (is_null($vNEAvailability) || (is_array($vNEAvailability) && empty($vNEAvailability))) {
            unset($this->VNEAvailability);
        } else {
            $this->VNEAvailability = $vNEAvailability;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NetworkProductResiliencyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
