<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OffnetLineManagementDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OffnetLineManagementDetails
 * @subpackage Structs
 */
class OffnetLineManagementDetails extends AbstractStructBase
{
    /**
     * The H24Retrains
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $H24Retrains;
    /**
     * The ILQCalculationDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ILQCalculationDate;
    /**
     * The IndicativeLineQuality
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IndicativeLineQuality;
    /**
     * The Interleaving
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Interleaving;
    /**
     * The MTBEDownstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MTBEDownstream;
    /**
     * The MTBEUpstream
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MTBEUpstream;
    /**
     * The MTBR
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MTBR;
    /**
     * Constructor method for OffnetLineManagementDetails
     * @uses OffnetLineManagementDetails::setH24Retrains()
     * @uses OffnetLineManagementDetails::setILQCalculationDate()
     * @uses OffnetLineManagementDetails::setIndicativeLineQuality()
     * @uses OffnetLineManagementDetails::setInterleaving()
     * @uses OffnetLineManagementDetails::setMTBEDownstream()
     * @uses OffnetLineManagementDetails::setMTBEUpstream()
     * @uses OffnetLineManagementDetails::setMTBR()
     * @param string $h24Retrains
     * @param string $iLQCalculationDate
     * @param string $indicativeLineQuality
     * @param string $interleaving
     * @param string $mTBEDownstream
     * @param string $mTBEUpstream
     * @param string $mTBR
     */
    public function __construct($h24Retrains = null, $iLQCalculationDate = null, $indicativeLineQuality = null, $interleaving = null, $mTBEDownstream = null, $mTBEUpstream = null, $mTBR = null)
    {
        $this
            ->setH24Retrains($h24Retrains)
            ->setILQCalculationDate($iLQCalculationDate)
            ->setIndicativeLineQuality($indicativeLineQuality)
            ->setInterleaving($interleaving)
            ->setMTBEDownstream($mTBEDownstream)
            ->setMTBEUpstream($mTBEUpstream)
            ->setMTBR($mTBR);
    }
    /**
     * Get H24Retrains value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getH24Retrains()
    {
        return isset($this->H24Retrains) ? $this->H24Retrains : null;
    }
    /**
     * Set H24Retrains value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $h24Retrains
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setH24Retrains($h24Retrains = null)
    {
        // validation for constraint: string
        if (!is_null($h24Retrains) && !is_string($h24Retrains)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($h24Retrains)), __LINE__);
        }
        if (is_null($h24Retrains) || (is_array($h24Retrains) && empty($h24Retrains))) {
            unset($this->H24Retrains);
        } else {
            $this->H24Retrains = $h24Retrains;
        }
        return $this;
    }
    /**
     * Get ILQCalculationDate value
     * @return string|null
     */
    public function getILQCalculationDate()
    {
        return $this->ILQCalculationDate;
    }
    /**
     * Set ILQCalculationDate value
     * @param string $iLQCalculationDate
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setILQCalculationDate($iLQCalculationDate = null)
    {
        // validation for constraint: string
        if (!is_null($iLQCalculationDate) && !is_string($iLQCalculationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iLQCalculationDate)), __LINE__);
        }
        $this->ILQCalculationDate = $iLQCalculationDate;
        return $this;
    }
    /**
     * Get IndicativeLineQuality value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIndicativeLineQuality()
    {
        return isset($this->IndicativeLineQuality) ? $this->IndicativeLineQuality : null;
    }
    /**
     * Set IndicativeLineQuality value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $indicativeLineQuality
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setIndicativeLineQuality($indicativeLineQuality = null)
    {
        // validation for constraint: string
        if (!is_null($indicativeLineQuality) && !is_string($indicativeLineQuality)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($indicativeLineQuality)), __LINE__);
        }
        if (is_null($indicativeLineQuality) || (is_array($indicativeLineQuality) && empty($indicativeLineQuality))) {
            unset($this->IndicativeLineQuality);
        } else {
            $this->IndicativeLineQuality = $indicativeLineQuality;
        }
        return $this;
    }
    /**
     * Get Interleaving value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInterleaving()
    {
        return isset($this->Interleaving) ? $this->Interleaving : null;
    }
    /**
     * Set Interleaving value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $interleaving
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setInterleaving($interleaving = null)
    {
        // validation for constraint: string
        if (!is_null($interleaving) && !is_string($interleaving)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($interleaving)), __LINE__);
        }
        if (is_null($interleaving) || (is_array($interleaving) && empty($interleaving))) {
            unset($this->Interleaving);
        } else {
            $this->Interleaving = $interleaving;
        }
        return $this;
    }
    /**
     * Get MTBEDownstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMTBEDownstream()
    {
        return isset($this->MTBEDownstream) ? $this->MTBEDownstream : null;
    }
    /**
     * Set MTBEDownstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mTBEDownstream
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setMTBEDownstream($mTBEDownstream = null)
    {
        // validation for constraint: string
        if (!is_null($mTBEDownstream) && !is_string($mTBEDownstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mTBEDownstream)), __LINE__);
        }
        if (is_null($mTBEDownstream) || (is_array($mTBEDownstream) && empty($mTBEDownstream))) {
            unset($this->MTBEDownstream);
        } else {
            $this->MTBEDownstream = $mTBEDownstream;
        }
        return $this;
    }
    /**
     * Get MTBEUpstream value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMTBEUpstream()
    {
        return isset($this->MTBEUpstream) ? $this->MTBEUpstream : null;
    }
    /**
     * Set MTBEUpstream value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mTBEUpstream
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setMTBEUpstream($mTBEUpstream = null)
    {
        // validation for constraint: string
        if (!is_null($mTBEUpstream) && !is_string($mTBEUpstream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mTBEUpstream)), __LINE__);
        }
        if (is_null($mTBEUpstream) || (is_array($mTBEUpstream) && empty($mTBEUpstream))) {
            unset($this->MTBEUpstream);
        } else {
            $this->MTBEUpstream = $mTBEUpstream;
        }
        return $this;
    }
    /**
     * Get MTBR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMTBR()
    {
        return isset($this->MTBR) ? $this->MTBR : null;
    }
    /**
     * Set MTBR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mTBR
     * @return \StructType\OffnetLineManagementDetails
     */
    public function setMTBR($mTBR = null)
    {
        // validation for constraint: string
        if (!is_null($mTBR) && !is_string($mTBR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mTBR)), __LINE__);
        }
        if (is_null($mTBR) || (is_array($mTBR) && empty($mTBR))) {
            unset($this->MTBR);
        } else {
            $this->MTBR = $mTBR;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OffnetLineManagementDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
