<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrimaryAccessCASR StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:PrimaryAccessCASR
 * @subpackage Structs
 */
class PrimaryAccessCASR extends PrimaryAccessIdentifier
{
    /**
     * The CASR
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CASR;
    /**
     * Constructor method for PrimaryAccessCASR
     * @uses PrimaryAccessCASR::setCASR()
     * @param string $cASR
     */
    public function __construct($cASR = null)
    {
        $this
            ->setCASR($cASR);
    }
    /**
     * Get CASR value
     * @return string|null
     */
    public function getCASR()
    {
        return $this->CASR;
    }
    /**
     * Set CASR value
     * @param string $cASR
     * @return \StructType\PrimaryAccessCASR
     */
    public function setCASR($cASR = null)
    {
        // validation for constraint: string
        if (!is_null($cASR) && !is_string($cASR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cASR)), __LINE__);
        }
        $this->CASR = $cASR;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PrimaryAccessCASR
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
