<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductAttribute StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ProductAttribute
 * @subpackage Structs
 */
class ProductAttribute extends AbstractStructBase
{
    /**
     * The AttributeName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AttributeName;
    /**
     * The AttributeValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AttributeValue;
    /**
     * Constructor method for ProductAttribute
     * @uses ProductAttribute::setAttributeName()
     * @uses ProductAttribute::setAttributeValue()
     * @param string $attributeName
     * @param string $attributeValue
     */
    public function __construct($attributeName = null, $attributeValue = null)
    {
        $this
            ->setAttributeName($attributeName)
            ->setAttributeValue($attributeValue);
    }
    /**
     * Get AttributeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAttributeName()
    {
        return isset($this->AttributeName) ? $this->AttributeName : null;
    }
    /**
     * Set AttributeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $attributeName
     * @return \StructType\ProductAttribute
     */
    public function setAttributeName($attributeName = null)
    {
        // validation for constraint: string
        if (!is_null($attributeName) && !is_string($attributeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeName)), __LINE__);
        }
        if (is_null($attributeName) || (is_array($attributeName) && empty($attributeName))) {
            unset($this->AttributeName);
        } else {
            $this->AttributeName = $attributeName;
        }
        return $this;
    }
    /**
     * Get AttributeValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAttributeValue()
    {
        return isset($this->AttributeValue) ? $this->AttributeValue : null;
    }
    /**
     * Set AttributeValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $attributeValue
     * @return \StructType\ProductAttribute
     */
    public function setAttributeValue($attributeValue = null)
    {
        // validation for constraint: string
        if (!is_null($attributeValue) && !is_string($attributeValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeValue)), __LINE__);
        }
        if (is_null($attributeValue) || (is_array($attributeValue) && empty($attributeValue))) {
            unset($this->AttributeValue);
        } else {
            $this->AttributeValue = $attributeValue;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductAttribute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
