<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThroughputSpeedType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ThroughputSpeedType
 * @subpackage Structs
 */
class ThroughputSpeedType extends AbstractStructBase
{
    /**
     * The DownstreamThroughputBottom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamThroughputBottom;
    /**
     * The DownstreamThroughputMin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamThroughputMin;
    /**
     * The DownstreamThroughputTop
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DownstreamThroughputTop;
    /**
     * The SpeedCategory
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SpeedCategory;
    /**
     * The TimeOfDay
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TimeOfDay;
    /**
     * The UpstreamThroughputBottom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamThroughputBottom;
    /**
     * The UpstreamThroughputMin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamThroughputMin;
    /**
     * The UpstreamThroughputTop
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpstreamThroughputTop;
    /**
     * Constructor method for ThroughputSpeedType
     * @uses ThroughputSpeedType::setDownstreamThroughputBottom()
     * @uses ThroughputSpeedType::setDownstreamThroughputMin()
     * @uses ThroughputSpeedType::setDownstreamThroughputTop()
     * @uses ThroughputSpeedType::setSpeedCategory()
     * @uses ThroughputSpeedType::setTimeOfDay()
     * @uses ThroughputSpeedType::setUpstreamThroughputBottom()
     * @uses ThroughputSpeedType::setUpstreamThroughputMin()
     * @uses ThroughputSpeedType::setUpstreamThroughputTop()
     * @param string $downstreamThroughputBottom
     * @param string $downstreamThroughputMin
     * @param string $downstreamThroughputTop
     * @param string $speedCategory
     * @param string $timeOfDay
     * @param string $upstreamThroughputBottom
     * @param string $upstreamThroughputMin
     * @param string $upstreamThroughputTop
     */
    public function __construct($downstreamThroughputBottom = null, $downstreamThroughputMin = null, $downstreamThroughputTop = null, $speedCategory = null, $timeOfDay = null, $upstreamThroughputBottom = null, $upstreamThroughputMin = null, $upstreamThroughputTop = null)
    {
        $this
            ->setDownstreamThroughputBottom($downstreamThroughputBottom)
            ->setDownstreamThroughputMin($downstreamThroughputMin)
            ->setDownstreamThroughputTop($downstreamThroughputTop)
            ->setSpeedCategory($speedCategory)
            ->setTimeOfDay($timeOfDay)
            ->setUpstreamThroughputBottom($upstreamThroughputBottom)
            ->setUpstreamThroughputMin($upstreamThroughputMin)
            ->setUpstreamThroughputTop($upstreamThroughputTop);
    }
    /**
     * Get DownstreamThroughputBottom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamThroughputBottom()
    {
        return isset($this->DownstreamThroughputBottom) ? $this->DownstreamThroughputBottom : null;
    }
    /**
     * Set DownstreamThroughputBottom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamThroughputBottom
     * @return \StructType\ThroughputSpeedType
     */
    public function setDownstreamThroughputBottom($downstreamThroughputBottom = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamThroughputBottom) && !is_string($downstreamThroughputBottom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamThroughputBottom)), __LINE__);
        }
        if (is_null($downstreamThroughputBottom) || (is_array($downstreamThroughputBottom) && empty($downstreamThroughputBottom))) {
            unset($this->DownstreamThroughputBottom);
        } else {
            $this->DownstreamThroughputBottom = $downstreamThroughputBottom;
        }
        return $this;
    }
    /**
     * Get DownstreamThroughputMin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamThroughputMin()
    {
        return isset($this->DownstreamThroughputMin) ? $this->DownstreamThroughputMin : null;
    }
    /**
     * Set DownstreamThroughputMin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamThroughputMin
     * @return \StructType\ThroughputSpeedType
     */
    public function setDownstreamThroughputMin($downstreamThroughputMin = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamThroughputMin) && !is_string($downstreamThroughputMin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamThroughputMin)), __LINE__);
        }
        if (is_null($downstreamThroughputMin) || (is_array($downstreamThroughputMin) && empty($downstreamThroughputMin))) {
            unset($this->DownstreamThroughputMin);
        } else {
            $this->DownstreamThroughputMin = $downstreamThroughputMin;
        }
        return $this;
    }
    /**
     * Get DownstreamThroughputTop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDownstreamThroughputTop()
    {
        return isset($this->DownstreamThroughputTop) ? $this->DownstreamThroughputTop : null;
    }
    /**
     * Set DownstreamThroughputTop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $downstreamThroughputTop
     * @return \StructType\ThroughputSpeedType
     */
    public function setDownstreamThroughputTop($downstreamThroughputTop = null)
    {
        // validation for constraint: string
        if (!is_null($downstreamThroughputTop) && !is_string($downstreamThroughputTop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($downstreamThroughputTop)), __LINE__);
        }
        if (is_null($downstreamThroughputTop) || (is_array($downstreamThroughputTop) && empty($downstreamThroughputTop))) {
            unset($this->DownstreamThroughputTop);
        } else {
            $this->DownstreamThroughputTop = $downstreamThroughputTop;
        }
        return $this;
    }
    /**
     * Get SpeedCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSpeedCategory()
    {
        return isset($this->SpeedCategory) ? $this->SpeedCategory : null;
    }
    /**
     * Set SpeedCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $speedCategory
     * @return \StructType\ThroughputSpeedType
     */
    public function setSpeedCategory($speedCategory = null)
    {
        // validation for constraint: string
        if (!is_null($speedCategory) && !is_string($speedCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($speedCategory)), __LINE__);
        }
        if (is_null($speedCategory) || (is_array($speedCategory) && empty($speedCategory))) {
            unset($this->SpeedCategory);
        } else {
            $this->SpeedCategory = $speedCategory;
        }
        return $this;
    }
    /**
     * Get TimeOfDay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTimeOfDay()
    {
        return isset($this->TimeOfDay) ? $this->TimeOfDay : null;
    }
    /**
     * Set TimeOfDay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $timeOfDay
     * @return \StructType\ThroughputSpeedType
     */
    public function setTimeOfDay($timeOfDay = null)
    {
        // validation for constraint: string
        if (!is_null($timeOfDay) && !is_string($timeOfDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeOfDay)), __LINE__);
        }
        if (is_null($timeOfDay) || (is_array($timeOfDay) && empty($timeOfDay))) {
            unset($this->TimeOfDay);
        } else {
            $this->TimeOfDay = $timeOfDay;
        }
        return $this;
    }
    /**
     * Get UpstreamThroughputBottom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamThroughputBottom()
    {
        return isset($this->UpstreamThroughputBottom) ? $this->UpstreamThroughputBottom : null;
    }
    /**
     * Set UpstreamThroughputBottom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamThroughputBottom
     * @return \StructType\ThroughputSpeedType
     */
    public function setUpstreamThroughputBottom($upstreamThroughputBottom = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamThroughputBottom) && !is_string($upstreamThroughputBottom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamThroughputBottom)), __LINE__);
        }
        if (is_null($upstreamThroughputBottom) || (is_array($upstreamThroughputBottom) && empty($upstreamThroughputBottom))) {
            unset($this->UpstreamThroughputBottom);
        } else {
            $this->UpstreamThroughputBottom = $upstreamThroughputBottom;
        }
        return $this;
    }
    /**
     * Get UpstreamThroughputMin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamThroughputMin()
    {
        return isset($this->UpstreamThroughputMin) ? $this->UpstreamThroughputMin : null;
    }
    /**
     * Set UpstreamThroughputMin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamThroughputMin
     * @return \StructType\ThroughputSpeedType
     */
    public function setUpstreamThroughputMin($upstreamThroughputMin = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamThroughputMin) && !is_string($upstreamThroughputMin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamThroughputMin)), __LINE__);
        }
        if (is_null($upstreamThroughputMin) || (is_array($upstreamThroughputMin) && empty($upstreamThroughputMin))) {
            unset($this->UpstreamThroughputMin);
        } else {
            $this->UpstreamThroughputMin = $upstreamThroughputMin;
        }
        return $this;
    }
    /**
     * Get UpstreamThroughputTop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpstreamThroughputTop()
    {
        return isset($this->UpstreamThroughputTop) ? $this->UpstreamThroughputTop : null;
    }
    /**
     * Set UpstreamThroughputTop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upstreamThroughputTop
     * @return \StructType\ThroughputSpeedType
     */
    public function setUpstreamThroughputTop($upstreamThroughputTop = null)
    {
        // validation for constraint: string
        if (!is_null($upstreamThroughputTop) && !is_string($upstreamThroughputTop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upstreamThroughputTop)), __LINE__);
        }
        if (is_null($upstreamThroughputTop) || (is_array($upstreamThroughputTop) && empty($upstreamThroughputTop))) {
            unset($this->UpstreamThroughputTop);
        } else {
            $this->UpstreamThroughputTop = $upstreamThroughputTop;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ThroughputSpeedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
