<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TiePairBandwidthType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TiePairBandwidthType
 * @subpackage Structs
 */
class TiePairBandwidthType extends AbstractStructBase
{
    /**
     * The FourPair
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FourTiePairBandwidthType
     */
    public $FourPair;
    /**
     * The TwoPair
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TwoTiePairBandwidthType
     */
    public $TwoPair;
    /**
     * Constructor method for TiePairBandwidthType
     * @uses TiePairBandwidthType::setFourPair()
     * @uses TiePairBandwidthType::setTwoPair()
     * @param \StructType\FourTiePairBandwidthType $fourPair
     * @param \StructType\TwoTiePairBandwidthType $twoPair
     */
    public function __construct(\StructType\FourTiePairBandwidthType $fourPair = null, \StructType\TwoTiePairBandwidthType $twoPair = null)
    {
        $this
            ->setFourPair($fourPair)
            ->setTwoPair($twoPair);
    }
    /**
     * Get FourPair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FourTiePairBandwidthType|null
     */
    public function getFourPair()
    {
        return isset($this->FourPair) ? $this->FourPair : null;
    }
    /**
     * Set FourPair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\FourTiePairBandwidthType $fourPair
     * @return \StructType\TiePairBandwidthType
     */
    public function setFourPair(\StructType\FourTiePairBandwidthType $fourPair = null)
    {
        if (is_null($fourPair) || (is_array($fourPair) && empty($fourPair))) {
            unset($this->FourPair);
        } else {
            $this->FourPair = $fourPair;
        }
        return $this;
    }
    /**
     * Get TwoPair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TwoTiePairBandwidthType|null
     */
    public function getTwoPair()
    {
        return isset($this->TwoPair) ? $this->TwoPair : null;
    }
    /**
     * Set TwoPair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TwoTiePairBandwidthType $twoPair
     * @return \StructType\TiePairBandwidthType
     */
    public function setTwoPair(\StructType\TwoTiePairBandwidthType $twoPair = null)
    {
        if (is_null($twoPair) || (is_array($twoPair) && empty($twoPair))) {
            unset($this->TwoPair);
        } else {
            $this->TwoPair = $twoPair;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TiePairBandwidthType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
