<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TwoTiePairBandwidthType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TwoTiePairBandwidthType
 * @subpackage Structs
 */
class TwoTiePairBandwidthType extends AbstractStructBase
{
    /**
     * The EstimatedDownstreamSpeed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EstimatedDownstreamSpeed;
    /**
     * The MinThreshold
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MinThreshold;
    /**
     * Constructor method for TwoTiePairBandwidthType
     * @uses TwoTiePairBandwidthType::setEstimatedDownstreamSpeed()
     * @uses TwoTiePairBandwidthType::setMinThreshold()
     * @param string $estimatedDownstreamSpeed
     * @param string $minThreshold
     */
    public function __construct($estimatedDownstreamSpeed = null, $minThreshold = null)
    {
        $this
            ->setEstimatedDownstreamSpeed($estimatedDownstreamSpeed)
            ->setMinThreshold($minThreshold);
    }
    /**
     * Get EstimatedDownstreamSpeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEstimatedDownstreamSpeed()
    {
        return isset($this->EstimatedDownstreamSpeed) ? $this->EstimatedDownstreamSpeed : null;
    }
    /**
     * Set EstimatedDownstreamSpeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $estimatedDownstreamSpeed
     * @return \StructType\TwoTiePairBandwidthType
     */
    public function setEstimatedDownstreamSpeed($estimatedDownstreamSpeed = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedDownstreamSpeed) && !is_string($estimatedDownstreamSpeed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($estimatedDownstreamSpeed)), __LINE__);
        }
        if (is_null($estimatedDownstreamSpeed) || (is_array($estimatedDownstreamSpeed) && empty($estimatedDownstreamSpeed))) {
            unset($this->EstimatedDownstreamSpeed);
        } else {
            $this->EstimatedDownstreamSpeed = $estimatedDownstreamSpeed;
        }
        return $this;
    }
    /**
     * Get MinThreshold value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMinThreshold()
    {
        return isset($this->MinThreshold) ? $this->MinThreshold : null;
    }
    /**
     * Set MinThreshold value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $minThreshold
     * @return \StructType\TwoTiePairBandwidthType
     */
    public function setMinThreshold($minThreshold = null)
    {
        // validation for constraint: string
        if (!is_null($minThreshold) && !is_string($minThreshold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minThreshold)), __LINE__);
        }
        if (is_null($minThreshold) || (is_array($minThreshold) && empty($minThreshold))) {
            unset($this->MinThreshold);
        } else {
            $this->MinThreshold = $minThreshold;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TwoTiePairBandwidthType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
