<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WorkingLineType StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WorkingLineType
 * @subpackage Structs
 */
class WorkingLineType extends AbstractStructBase
{
    /**
     * The InstallationDN
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InstallationDN;
    /**
     * The InstallationType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InstallationType;
    /**
     * The OpenOrderDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfOpenOrderInfo
     */
    public $OpenOrderDetails;
    /**
     * The PartialDN
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PartialDN;
    /**
     * The ProductType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProductType;
    /**
     * The TerminationType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TerminationType;
    /**
     * The WorkingLineLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WorkingLineLocation;
    /**
     * Constructor method for WorkingLineType
     * @uses WorkingLineType::setInstallationDN()
     * @uses WorkingLineType::setInstallationType()
     * @uses WorkingLineType::setOpenOrderDetails()
     * @uses WorkingLineType::setPartialDN()
     * @uses WorkingLineType::setProductType()
     * @uses WorkingLineType::setTerminationType()
     * @uses WorkingLineType::setWorkingLineLocation()
     * @param string $installationDN
     * @param string $installationType
     * @param \ArrayType\ArrayOfOpenOrderInfo $openOrderDetails
     * @param string $partialDN
     * @param string $productType
     * @param string $terminationType
     * @param string $workingLineLocation
     */
    public function __construct($installationDN = null, $installationType = null, \ArrayType\ArrayOfOpenOrderInfo $openOrderDetails = null, $partialDN = null, $productType = null, $terminationType = null, $workingLineLocation = null)
    {
        $this
            ->setInstallationDN($installationDN)
            ->setInstallationType($installationType)
            ->setOpenOrderDetails($openOrderDetails)
            ->setPartialDN($partialDN)
            ->setProductType($productType)
            ->setTerminationType($terminationType)
            ->setWorkingLineLocation($workingLineLocation);
    }
    /**
     * Get InstallationDN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInstallationDN()
    {
        return isset($this->InstallationDN) ? $this->InstallationDN : null;
    }
    /**
     * Set InstallationDN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $installationDN
     * @return \StructType\WorkingLineType
     */
    public function setInstallationDN($installationDN = null)
    {
        // validation for constraint: string
        if (!is_null($installationDN) && !is_string($installationDN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($installationDN)), __LINE__);
        }
        if (is_null($installationDN) || (is_array($installationDN) && empty($installationDN))) {
            unset($this->InstallationDN);
        } else {
            $this->InstallationDN = $installationDN;
        }
        return $this;
    }
    /**
     * Get InstallationType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInstallationType()
    {
        return isset($this->InstallationType) ? $this->InstallationType : null;
    }
    /**
     * Set InstallationType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $installationType
     * @return \StructType\WorkingLineType
     */
    public function setInstallationType($installationType = null)
    {
        // validation for constraint: string
        if (!is_null($installationType) && !is_string($installationType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($installationType)), __LINE__);
        }
        if (is_null($installationType) || (is_array($installationType) && empty($installationType))) {
            unset($this->InstallationType);
        } else {
            $this->InstallationType = $installationType;
        }
        return $this;
    }
    /**
     * Get OpenOrderDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfOpenOrderInfo|null
     */
    public function getOpenOrderDetails()
    {
        return isset($this->OpenOrderDetails) ? $this->OpenOrderDetails : null;
    }
    /**
     * Set OpenOrderDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfOpenOrderInfo $openOrderDetails
     * @return \StructType\WorkingLineType
     */
    public function setOpenOrderDetails(\ArrayType\ArrayOfOpenOrderInfo $openOrderDetails = null)
    {
        if (is_null($openOrderDetails) || (is_array($openOrderDetails) && empty($openOrderDetails))) {
            unset($this->OpenOrderDetails);
        } else {
            $this->OpenOrderDetails = $openOrderDetails;
        }
        return $this;
    }
    /**
     * Get PartialDN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPartialDN()
    {
        return isset($this->PartialDN) ? $this->PartialDN : null;
    }
    /**
     * Set PartialDN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $partialDN
     * @return \StructType\WorkingLineType
     */
    public function setPartialDN($partialDN = null)
    {
        // validation for constraint: string
        if (!is_null($partialDN) && !is_string($partialDN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($partialDN)), __LINE__);
        }
        if (is_null($partialDN) || (is_array($partialDN) && empty($partialDN))) {
            unset($this->PartialDN);
        } else {
            $this->PartialDN = $partialDN;
        }
        return $this;
    }
    /**
     * Get ProductType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProductType()
    {
        return isset($this->ProductType) ? $this->ProductType : null;
    }
    /**
     * Set ProductType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $productType
     * @return \StructType\WorkingLineType
     */
    public function setProductType($productType = null)
    {
        // validation for constraint: string
        if (!is_null($productType) && !is_string($productType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productType)), __LINE__);
        }
        if (is_null($productType) || (is_array($productType) && empty($productType))) {
            unset($this->ProductType);
        } else {
            $this->ProductType = $productType;
        }
        return $this;
    }
    /**
     * Get TerminationType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTerminationType()
    {
        return isset($this->TerminationType) ? $this->TerminationType : null;
    }
    /**
     * Set TerminationType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $terminationType
     * @return \StructType\WorkingLineType
     */
    public function setTerminationType($terminationType = null)
    {
        // validation for constraint: string
        if (!is_null($terminationType) && !is_string($terminationType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($terminationType)), __LINE__);
        }
        if (is_null($terminationType) || (is_array($terminationType) && empty($terminationType))) {
            unset($this->TerminationType);
        } else {
            $this->TerminationType = $terminationType;
        }
        return $this;
    }
    /**
     * Get WorkingLineLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWorkingLineLocation()
    {
        return isset($this->WorkingLineLocation) ? $this->WorkingLineLocation : null;
    }
    /**
     * Set WorkingLineLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $workingLineLocation
     * @return \StructType\WorkingLineType
     */
    public function setWorkingLineLocation($workingLineLocation = null)
    {
        // validation for constraint: string
        if (!is_null($workingLineLocation) && !is_string($workingLineLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($workingLineLocation)), __LINE__);
        }
        if (is_null($workingLineLocation) || (is_array($workingLineLocation) && empty($workingLineLocation))) {
            unset($this->WorkingLineLocation);
        } else {
            $this->WorkingLineLocation = $workingLineLocation;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WorkingLineType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
